#include <string>
#include <iostream>
#include "Book.h"
using namespace std;


Book::Book() : LibraryItem()
{
	_Book_Loan = NULL;
	_hold_event = NULL;
	loan_due_date = new Clock(9999,1,1,1,1);
}


Book::Book(string BarcodeNumber, string title, string Author_Name, int loan_length) :
LibraryItem(BarcodeNumber, title), _Author_Name(Author_Name), _loan_length(loan_length)
{
	_Book_Loan = NULL;
	_hold_event = NULL;
	loan_due_date = new Clock(9999,1,1,1,1);
}	


void Book::Lend(LoanEvent *A_Book_Loan)
{	
	Clock temp_clock;
	loan_due_date = new Clock(temp_clock.GetPresentYear(),
							  temp_clock.GetPresentMonth(),
							  temp_clock.GetPresentDay() + _loan_length,
							  temp_clock.GetPresentHour(),
							  temp_clock.GetPresentMinute());
	_Book_Loan=A_Book_Loan;
}



void Book::Return()
{
	if(OnHold())
	{
		cout<< "PLEASE HOLD THIS BOOK FOR 48 HOURS IN LIBRARY!" <<endl;
		cout<< "And notify member " << _hold_event->GetMember()->GetLibraryNumber() << " "; 
		cout<< _hold_event->GetMember()->GetName() << endl;
	}
	if(this->IsLoanOverdue())
		cout <<"BOOK LOAN OVERDUE !"<< endl;
	_Book_Loan = NULL;
}


bool Book::OnLoan()
{
	if (_Book_Loan == NULL)
		return false;
	else 
		return true;
}


bool Book::OnHold()
{
	if (_hold_event == NULL)
		return false;
	else
		return true;
}


void Book::Hold(HoldEvent *Book_Hold_Event)
{
	Clock temp_clock;
	if (this->OnLoan())
	{
		loan_due_date = new Clock(temp_clock.GetPresentYear(),
								  temp_clock.GetPresentMonth(),
								  temp_clock.GetPresentDay() + 2,
								  temp_clock.GetPresentHour(),
								  temp_clock.GetPresentMinute());
	}
	else
	{
		loan_due_date = new Clock(temp_clock.GetPresentYear(),
								  temp_clock.GetPresentMonth(),
								  temp_clock.GetPresentDay() + 1,
								  temp_clock.GetPresentHour(),
								  temp_clock.GetPresentMinute());
	}
	_hold_event = Book_Hold_Event;
}


void Book::CancelHold()
{
	_hold_event = NULL;
}

HoldEvent* Book::GetBookHoldEvent()
{
	return _hold_event;
}

string Book::GetAuthorName()const
{
	return _Author_Name;
}

LoanEvent* Book::GetBookLoanEvent()
{
	return _Book_Loan;
}

int Book::GetLoanLength()const
{
	return _loan_length;
}

bool Book::IsLoanOverdue()
{
	if (loan_due_date->Is_earlier_than_present_time())
		return true;
	else
		return false;
}

Clock* Book::GetLoanDueDate()
{
	return loan_due_date;
}

void Book::Output()
{
	cout<<"The details of the Book:  "<< endl;
	LibraryItem::Output();	

	cout << "Author's Name	:"<<_Author_Name << endl;
}