#include <iostream>
#include <string>
#include "BookCollection.h"
using namespace std;


 
BookCollection::BookCollection()
{

}


void BookCollection::AddBook(string Book_Barcode, string title ,string author_name, int loan_length)
{
	Book newBook(Book_Barcode, title, author_name, loan_length);
	_book.push_back(newBook);
}


void BookCollection::RemoveBook(string book_barcode)
{
	_book.erase(GetBookByBarcode(book_barcode));
}


Book *BookCollection::GetBookByBarcode(string book_barcode)
{
	
	Book temp;
	for (int i =0; i<_book.size(); i++)
	{
		temp = _book[i];
		if (temp.GetBarcodeNumber() == book_barcode)
		{
			return &_book[i]; 
		};
	};
	return NULL;
}

BookCollection *BookCollection::GetBookByTitle(string book_title)
{
	Book temp;
	BookCollection* temp_book_collection = new BookCollection;
	int flag = 0;

	for (int i =0; i<_book.size(); i++)
	{
		temp = _book[i];
		if (temp.GetTitle() == book_title)
		{
			temp_book_collection->AddBook(_book[i].GetBarcodeNumber(), _book[i].GetTitle(), _book[i].GetAuthorName(), _book[i].GetLoanLength());
			flag = 1;
		};
	};
	
	if (flag ==0)
	{
		cout << "BOOK NOT FOUND!"<<endl;
		return NULL;
	}
	else 
		return temp_book_collection;
}

BookCollection *BookCollection::GetBookByAuthor(string authorname)
{
	Book temp;
	BookCollection* temp_book_collection = new BookCollection;
	int flag = 0;

	for (int i =0; i<_book.size(); i++)
	{
		temp = _book[i];
		if (temp.GetAuthorName() == authorname)
		{
			temp_book_collection->AddBook(_book[i].GetBarcodeNumber(), _book[i].GetTitle(), _book[i].GetAuthorName(), _book[i].GetLoanLength());
			flag = 1;
		};
	};
	
	if (flag ==0)
	{
		cout << "BOOK NOT FOUND!"<<endl;
		return NULL;
	}
	else 
		return temp_book_collection;
}

BookCollection* BookCollection::GetHoldFreeBookByTitle(string title)
{
	Book temp;
	BookCollection* temp_book_collection = new BookCollection;
	int flag = 0;

	for (int i =0; i<_book.size(); i++)
	{
		temp = _book[i];
		if ( (temp.GetTitle() == title) && (!temp.OnHold()) )
		{
			temp_book_collection->AddBook(	_book[i].GetBarcodeNumber(),
											_book[i].GetTitle(),
											_book[i].GetAuthorName(),
											_book[i].GetLoanLength());
			flag = 1;
		};
	};
	
	if (flag ==0)
		return NULL;
	else 
		return temp_book_collection;
}


void BookCollection::DisplayMemberWithOverdueBooks()
{
	Book temp;
	BookCollection* temp_book_collection = new BookCollection;
	int flag = 0;

	for (int i =0; i<_book.size(); i++)
	{
		temp = _book[i];
		if (temp.IsLoanOverdue())
		{
			cout << temp.GetBookLoanEvent()->GetMember()->GetName() << endl;
		};
	};
}

void BookCollection::Output()const
{
	Book all_book;
	
	if (_book.empty())
    {   
		cout << "No Book in the library" << endl;
	}
	else
	{
		for (int n = 0; n < _book.size() ; n++)
		{
			cout << "======================" << endl;
			all_book = _book[n];
			all_book.Output();
			if (all_book.OnLoan())
			{
				cout << "Book loan due date : ";
				all_book.GetLoanDueDate()->Output();
				cout << endl;
			}
			cout << "======================" << endl;
		};
	};
}
