#include <iostream>
#include <string>
#include "CDCollection.h"
using namespace std;

CDCollection::CDCollection()
{
}


void CDCollection::AddCD(string cd_title, string cd_barcode_num,string artist_name,string play_time, int loan_length)
{
	CD newCD(cd_title, cd_barcode_num, artist_name, play_time, loan_length);
	_All_CD.push_back(newCD);
}


void CDCollection::RemoveCD(string cd_barcode_number)
{
	_All_CD.erase(GetCDByBarcode(cd_barcode_number));
}


CD *CDCollection::GetCDByBarcode(string cd_barcode_number)
{
	CD cd_temp;
	for (int i =0; i<_All_CD.size(); i++)
	{
		cd_temp = _All_CD[i];
		if (cd_temp.GetBarcodeNumber() == cd_barcode_number)
		{
			return &_All_CD[i]; 
		};
	};
	return NULL;
}
 

CDCollection *CDCollection::GetCDByTitle(string CD_Name)
{
	CD cd_temp;
	CDCollection* temp_cd_collection = new CDCollection;
	int flag = 0;

	for (int i =0; i<_All_CD.size(); i++)
	{
		cd_temp = _All_CD[i];
		if (cd_temp.GetTitle() == CD_Name)
		{ 
			temp_cd_collection->AddCD(_All_CD[i].GetTitle(), _All_CD[i].GetBarcodeNumber(), _All_CD[i].GetArtistName(), _All_CD[i].GetPlayTime(), _All_CD[i].GetLoanLength());
			flag = 1;
		};
	};
	
	if (flag ==0)
	{
		cout << "CD NOT FOUND!"<<endl;
		return NULL;
	}
	else 
		return temp_cd_collection;
}

CDCollection *CDCollection::GetCDByArtist(string CD_Artist)
{
	CD cd_temp;
	CDCollection* temp_cd_collection = new CDCollection;
	int flag = 0;

	for (int i =0; i<_All_CD.size(); i++)
	{
		cd_temp = _All_CD[i];
		if (cd_temp.GetArtistName() == CD_Artist)
		{
			temp_cd_collection->AddCD(_All_CD[i].GetTitle(), _All_CD[i].GetBarcodeNumber(), 
									  _All_CD[i].GetArtistName(), _All_CD[i].GetPlayTime(),
									  _All_CD[i].GetLoanLength());
			flag = 1;
		};
	};
	
	if (flag ==0)
	{
		cout << "CD NOT FOUND!"<<endl;
		return NULL;
	}
	else 
		return temp_cd_collection;
}


CDCollection *CDCollection::GetHoldFreeCDByTitle(string title)
{
	CD cd_temp;
	CDCollection* temp_cd_collection = new CDCollection;
	int flag = 0;

	for (int i =0; i<_All_CD.size(); i++)
	{
		cd_temp = _All_CD[i];
		if ( (cd_temp.GetTitle() == title) && (!cd_temp.OnHold()) )
		{ 
			temp_cd_collection->AddCD(	_All_CD[i].GetTitle(),
										_All_CD[i].GetBarcodeNumber(),
										_All_CD[i].GetArtistName(),
										_All_CD[i].GetPlayTime(),
										_All_CD[i].GetLoanLength());
			flag = 1;
		};
	};
	
	if (flag ==0)
		return NULL;
	else 
		return temp_cd_collection;
}


void CDCollection::DisplayMemberWithOverdueCDs()
{
	CD cd_temp;
	CDCollection* temp_cd_collection = new CDCollection;
	int flag = 0;

	for (int i =0; i<_All_CD.size(); i++)
	{
		cd_temp = _All_CD[i];
		if (cd_temp.IsLoanOverdue())
		{ 
			cout << cd_temp.GetCDLoanEvent()->GetMember()->GetName() << endl;
		};
	};
}

void CDCollection::Output()const
{
	CD _cd;
	
	if (_All_CD.empty())
    {   
		cout << "No CD in the library" << endl;
	}
	else
	{
		for (int n = 0; n < _All_CD.size() ; n++)
		{
			_cd = _All_CD[n];
			_cd.Output();
			if (_cd.OnLoan())
			{
				cout << "CD loan due date : ";
				_cd.GetLoanDueDate()->Output();
				cout << endl;
			}
		};
	};
}
