#ifndef CDCOLLECTION_H
#define CDCOLLECTION_H

#include <string>
#include <vector>
#include "CD.h"
using namespace std;


class CDCollection
{
public:
	CDCollection();
	//---The current collection of CD is undefined.---
	// Pre   :True
	// Post  :True

	void AddCD(string cd_title, string cd_barcode_num,string artist_name,string play_time, int loan_length);
	//--- This function adds a new CD to the CDCollection---
	// Pre   :cd_title,cd_barcode_num,artist_name,play_time,loan_length!=NULL
	// Post  :newCD IsIn CDCollection

	void RemoveCD(string cd_barcode_number);
	//---Remove a CD by its barcode number, if the barcode match, the CD is removed---
	// Pre   :True
	// Post  :CD->GetBarcodeNumber()==cd_barcode_number && NOT(CD IsIn CDCollection)

	CD *GetCDByBarcode(string cd_barcode_number);
	// ---Search a CD by its barcode number, if the barcode match, return a pointer to the CD
	// else return NULL---
	// Pre   :True
	// Post  :CD->GetBarcodeNumber() == cd_barcode_number &&
    //           (CD IsIn CDCollection &&
    //            return CD)
	//		  OR
    //           return NULL

	CDCollection *GetCDByTitle(string CD_name);
	//---Search a CD by its name, if the name matched, return a pointer to the CDCollection else 
	//return NULL---
	// Pre   :True
	// Post  :CD->GetTitle() == CD_name &&
	//           (CD IsIn CDCollection &&
    //            return CD)
	//		  OR
    //           return NULL


	CDCollection *GetCDByArtist(string CD_Artist);
	//---Search a CD by its artist name, if the artist name matched, return a pointer to 	
	//CDCollection else return NULL---
	// Pre   :True
	// Post  :CD->GetArtistName() == CD_name &&
    //           (CD IsIn CDCollection &&
    //            return CD)
	//	      OR
    //           return NULL

	CDCollection *GetHoldFreeCDByTitle(string title);
	// --- To check whether there is duplicate copies of the CD with same title, if yes, return a 	
	//pointer to CDCollection else return NULL---
	// Pre   :True
	// Post  :CD->GetTitle()==title && !=OnHold() &&
    //           (CD IsIn CDCollection &&
    //            return CD)
	//	      OR
    //           return NULL

	void DisplayMemberWithOverdueCDs();
	//---To display a list of member with overdue CDs---
	// Pre	  : True
	// Post	  : CD->IsLoanOverdue()==true && OUTPUTS( details of member)


	void Output()const;
	//---To display all the CD details on the standard output---
	// Pre   :True
	// Post  :for_all CD,CD IsIn BookCollection : OUTPUT CD

private:
	vector <CD> _All_CD;
};

#endif

