#include "CD.h"
#include <iostream>

using namespace std;


CD::CD() :LibraryItem()
{
	_CD_Loan = NULL;
	_hold_event = NULL;
	loan_due_date = new Clock(9999,1,1,1,1);
}


CD::CD(string title, string BarcodeNumber, string Artist_Name, string Play_Time, int loan_length) :
LibraryItem(title, BarcodeNumber),_Artist_Name(Artist_Name),_Play_Time(Play_Time),_loan_length(loan_length)
{
	_CD_Loan = NULL;
	_hold_event = NULL;
	loan_due_date = new Clock(9999,1,1,1,1);
}	


void CD::Lend(LoanEvent *A_CD_Loan)
{	
	Clock temp_clock;
	loan_due_date = new Clock(temp_clock.GetPresentYear(),
							  temp_clock.GetPresentMonth(),
							  temp_clock.GetPresentDay() + _loan_length,
							  temp_clock.GetPresentHour(),
							  temp_clock.GetPresentMinute());
	_CD_Loan=A_CD_Loan;
}


void CD::Return()
{
	if(OnHold())
	{
		cout<< "PLEASE HOLD THIS CD FOR 48 HOURS IN LIBRARY!" <<endl;
		cout<< "And notify member " << _hold_event->GetMember()->GetLibraryNumber() << " ";
		cout<< _hold_event->GetMember()->GetName() << endl;
	}
	if(this->IsLoanOverdue())
		cout <<"BOOK LOAN OVERDUE !"<< endl;
	_CD_Loan = NULL;
	
}


bool CD::OnLoan()
{
	if (_CD_Loan == NULL)
		return false;
	else 
		return true;
}


bool CD::OnHold()
{
	if (_hold_event == NULL)
		return false;
	else
		return true;
}


void CD::Hold(HoldEvent *CD_Hold_Event)
{
	Clock temp_clock;
	if (this->OnLoan())
	{
		loan_due_date = new Clock(temp_clock.GetPresentYear(),
								  temp_clock.GetPresentMonth(),
								  temp_clock.GetPresentDay() + 2,
								  temp_clock.GetPresentHour(),
								  temp_clock.GetPresentMinute());
	}
	else
	{
		loan_due_date = new Clock(temp_clock.GetPresentYear(),
								  temp_clock.GetPresentMonth(),
								  temp_clock.GetPresentDay() + 1,
								  temp_clock.GetPresentHour(),
								  temp_clock.GetPresentMinute());
	}
	_hold_event = CD_Hold_Event;
}


void CD::CancelHold()
{
	_hold_event = NULL;
}


LoanEvent* CD::GetCDLoanEvent()
{
	return _CD_Loan;
}


HoldEvent* CD::GetCDHoldEvent()
{
	return _hold_event;
}


string CD::GetArtistName()
{
	return _Artist_Name;
}


string CD::GetPlayTime()
{
	return _Play_Time;
}


Clock* CD::GetLoanDueDate()
{
	return loan_due_date;
}


int CD::GetLoanLength()const
{
	return _loan_length;
}


bool CD::IsLoanOverdue()
{
	if (loan_due_date->Is_earlier_than_present_time())
		return true;
	else
		return false;
}


void CD::Output()
{
	cout<<"The details of the CD:  "<< endl;
	LibraryItem::Output();	

	cout << "Artist's Name	:"<<_Artist_Name << endl;
	cout << "Play Time	:" <<_Play_Time << endl;
}
