// Clock.cpp: implementation of the Clock class.
//
//////////////////////////////////////////////////////////////////////

#include "Clock.h"
#include <assert.h>
#include <iso646.h>
#include <iostream>
#include <iomanip>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Clock::Clock()
{
}

Clock::Clock(int year, int month, int day, int hour, int minute)
{
	// minute checking and conversion
	if (minute >= 60)
	{
		minute = minute - 60;
		hour++;
	}

	// hour checking and conversion
	if (hour >= 24)
	{
		hour = hour - 24;
		day++;
	}

	// month checking and conversion
	if (month > 12)
	{
		month = month - 12;
		year++;
	}

	// day checking and conversion
	int feb;
	
	if ((year%400) == 0)
		feb = 29;
	else 
		feb = 28;

	int months[12] = {31,feb,31,30,31,30,31,31,30,31,30,31};
	
	if (day > months[month-1])
	{
		day = day - months[month-1];
		month++;
	}

	Time _temp_time(hour, minute);
	Date _temp_date(day, month, year);
	_time = _temp_time;
	_date = _temp_date;
}

Clock::~Clock()
{

}


bool Clock::Is_same_as_present_time()
{	
	struct tm *newtime;
	newtime = this->GetPresentTime();
	Clock system_clock(newtime->tm_year + 1900, newtime->tm_mon + 1, newtime->tm_mday,
					   newtime->tm_hour, newtime->tm_min);

	return _date.Is_same_as(system_clock._date) and
		   _time.Is_same_as(system_clock._time);
}


bool Clock::Is_earlier_than_present_time()
{
	return ( (!this->Is_later_than_present_time()) && (!this->Is_same_as_present_time()) );
}


bool Clock::Is_later_than_present_time()
{
	struct tm *newtime;
	newtime = this->GetPresentTime(); 
	Clock system_clock(newtime->tm_year + 1900, newtime->tm_mon + 1, newtime->tm_mday,
					   newtime->tm_hour, newtime->tm_min);

	return _date.Is_later_than(system_clock._date) or
		   (_date.Is_same_as(system_clock._date) and
		   _time.Is_later_than(system_clock._time));
}


tm* Clock::GetPresentTime()
{
	struct tm *newtime;
    time_t long_time;

    time(&long_time);                
    newtime = localtime(&long_time); 
	return newtime;
}


int Clock::GetPresentDay()
{
	struct tm *newtime;
	newtime = this->GetPresentTime(); 
	return newtime->tm_mday;
}


int Clock::GetPresentHour()
{
	struct tm *newtime;
	newtime = this->GetPresentTime(); 
	return newtime->tm_hour;
}	


int Clock::GetPresentMinute()
{
	struct tm *newtime;
	newtime = this->GetPresentTime(); 
	return newtime->tm_min;
}


int Clock::GetPresentMonth()
{
	struct tm *newtime;
	newtime = this->GetPresentTime(); 
	return newtime->tm_mon + 1;
}


int Clock::GetPresentYear()
{
	struct tm *newtime;
	newtime = this->GetPresentTime(); 
	return newtime->tm_year + 1900;
}


void Clock::Output() const
{
	_time.Output();
	_date.Output();
}