#include "Date.h"
#include <assert.h>
#include <iso646.h>
#include <iostream>
#include <iomanip>
using namespace std;


Date::Date()
{
}


Date::Date(int day_nr, int month_nr, int year_nr)
 : _day_nr(day_nr), _month(month_nr, year_nr)
{
    assert(1 <= _day_nr and _day_nr <= _month.Days_in_month());
}


Date::Date(int day_nr, Month month)
 : _day_nr(day_nr), _month(month)
{
    assert(1 <= _day_nr and _day_nr <= _month.Days_in_month());
}



bool Date::Is_same_as(const Date &other_date) const
{
    return _month.Is_same_as(other_date._month) and
           (_day_nr == other_date._day_nr);
}


bool Date::Is_earlier_than(const Date &other_date) const
{
    return ( (!this->Is_later_than(other_date)) && (!this->Is_same_as(other_date)) );
}


bool Date::Is_later_than(const Date &other_date) const
{
    return _month.Is_later_than(other_date._month) or
           (_month.Is_same_as(other_date._month) and
            (_day_nr > other_date._day_nr));
}


Date Date::Next_day() const
{
    if (_day_nr < _month.Days_in_month())
        return Date(_day_nr+1, _month);
    else
        return Date(1, _month.Next_month());
}


int Date::Days_till(const Date &future_date) const
{
    int nr_days = 0;
 
    for (Date tmp = *this; 
         tmp.Is_earlier_than(future_date);
         tmp = tmp.Next_day())
        nr_days++;
 
    return nr_days;
}


void Date::Output() const
{
	cout << " " << _day_nr;
	_month.Output();
}

