#ifndef already_included_date
#define already_included_date

#include "Month.h"

// This class is designed to represent any date 
// (either in the past, or in the future).
// It assumes that the modern Gregorian calendar system
// is used for all dates.
class Date
{
private:
    Month _month;
    int _day_nr;
public:
    Date();
	//---create a Date object---
  	// Pre:  True
    // Post: True

    Date(int day_nr, int month_nr, int year_nr);
	//---Initialise all the member data and passed them as parameters to construct a Date object---
    // Pre:True    
    // Post: A Date object has been created

    Date(int day_nr, Month month);
	//---Initialise all the member data and passed them as parameters to construct a Date object---
    // Pre:True
    // Post:A Date object has been created

    void Output() const;
	//---Output the details of the day and the month to standard output---
    // Pre:  True
    // Post: OUTPUT _day_nr && for_all month, _month IsIn Date:OUTPUT MONTH

    bool Is_same_as(const Date &other_date) const;
	//---return true if and only if the date is same as other date----
    // Pre:  True
    // Post: return (_month'==other _date._month) && (_day_nr'==other _date._day_nr)

    bool Is_earlier_than(const Date &other_date) const; 
	//---return true if and only if the date is earlier than other date----
    // Pre:  True
    // Post: return (_month'<other _date._month) && (_day_nr'<other _date._day_nr)

    bool Is_later_than(const Date &other_calender) const; 
	//---return true if and only if the date is later than the other date---
 	// Pre:  True
    // Post: return (_month'>other _date._month) && (_day_nr'>other _date._day_nr)


    int Days_till(const Date &future_date) const;
	//---returns the number of days between the date and the future date and 0 otherwise---
    // Pre:  True
    // Post: return nr_days OR return 0

    Date Next_day() const;
	//---determine the date after the end of the month for leap year and non-leap year---
    // Pre:  True
    // Post: return (_day_nr'==_day_nr+1 && month'==_month) 
	//	     OR (_day_nr'==1 && _month'==_month.Next_month())
};

#endif