#ifndef HOLDEVENT_H
#define HOLDEVENT_H

#include <string>
#include "Member.h"
#include "Book.h"
#include "Video.h"
#include "CD.h"


using namespace std;

class Member;
class Book;
class CD;
class Video;
class HoldEvent
{

public:
	HoldEvent();
	//---create an empty HoldEvent object---
	//Pre: True
	//Post:True

	HoldEvent(Book *Book_In_Hold, Member *Member_In_Hold);
	//---A constructor to initialise the member data and passed the pointer to Book and Member as parameters---
	// Pre :Book_In_Hold!=NULL && Member_In_Hold!=NULL
	// Post:Book_In_hold->OnHold()==true && CD_In_Hold=NULL && Video_In_Hold=NULL

	HoldEvent(CD *CD_In_Hold, Member *Member_In_Hold);
	//---A constructor to initialise the member data and passed the pointer to CD and Member as parameters---
	// Pre :CD_In_Hold!=NULL && Member_In_Hold!=NULL
	// Post:CD_In_hold->OnHold()==true && Book_In_Hold=NULL && Video_In_Hold=NULL

	HoldEvent(Video *Video_In_Hold, Member *Member_In_Hold);
	//---A constructor to initialise the member data and passed the pointer to Video and Member as parameters---
	// Pre :Video_In_Hold!=NULL && Member_In_Hold!=NULL
	// Post:Video_In_hold->OnHold()==true && CD_In_Hold=NULL && Book_In_Hold=NULL

	Book *GetBook()const;
	//---return a pointer involved in the hold to Book---
	// Pre :True
	// Post:returns _Book_Hold

	Member *GetMember()const;
	//---return a pointer to the member involved in the hold to Member---
	// Pre :True
	// Post:returns _Member_Hold

	CD *GetCD()const;
	//---return a pointer to the CD involved in the hold to CD---
	// Pre :True
	// Post:returns _CD_Hold
	
	Video *GetVideo()const;
	//---return a pointer to the video involved in the hold to Video---
	// Pre :True
	// Post:returns _Video_Hold

	void OutputItem()const;
	//---Display the details of all the items involved in the hold---
	//Pre	:True
	//post	:OUTPUTS ( details of book involved in hold)

private:
	Book *_Book_Hold;
	CD *_CD_Hold;
	Video *_Video_Hold;
	Member *_Member_Hold;
	
};

#endif