#include "HoldItems.h"
#include <string>

#ifndef _BOOK_H
	#define _BOOK_H
	#include "Book.h"
#endif

#ifndef _CD_H
	#define _CD_H
	#include "CD.h"
#endif


#ifndef _VIDEO_H
	#define _VIDEO_H
	#include "Video.h"
#endif
using namespace std;

HoldItems::HoldItems()
{
}


void HoldItems::Hold(HoldEvent* hold_event)
{
	_All_Current_Hold_Events.push_back(*hold_event);
}


HoldEvent* HoldItems::GetHoldEvent(Book* Book_Hold, Member* Member_Hold)
{
	string _bar_code, bar_code;
	string _library_number, library_number;
	HoldEvent *temp_holdEvent;
	
	bar_code = Book_Hold->GetBarcodeNumber();
	library_number = Member_Hold->GetLibraryNumber();

	for (int i =0; i<_All_Current_Hold_Events.size(); i++)
	{
		temp_holdEvent = &_All_Current_Hold_Events[i];

		_library_number = temp_holdEvent->GetMember()->GetLibraryNumber();
		
		if (temp_holdEvent->GetBook!=NULL)
			_bar_code = temp_holdEvent->GetBook()->GetBarcodeNumber();

		if ( (_bar_code==bar_code) && (_library_number == library_number) )
			return &_All_Current_Hold_Events[i];
	}
	return NULL;
}


HoldEvent* HoldItems::GetHoldEvent(CD* CD_Hold, Member* Member_Hold)
{
	string _bar_code, bar_code;
	string _library_number, library_number;
	HoldEvent *temp_holdEvent;
	
	bar_code = CD_Hold->GetBarcodeNumber();
	library_number = Member_Hold->GetLibraryNumber();

	for (int i =0; i<_All_Current_Hold_Events.size(); i++)
	{
		temp_holdEvent = &_All_Current_Hold_Events[i];

		_library_number = temp_holdEvent->GetMember()->GetLibraryNumber();
		
		if (temp_holdEvent->GetCD!=NULL)
			_bar_code = temp_holdEvent->GetCD()->GetBarcodeNumber();

		if ( (_bar_code== bar_code) && (_library_number == library_number) )
			return &_All_Current_Hold_Events[i];
	}
	return NULL;
}


HoldEvent* HoldItems::GetHoldEvent(Video* Video_Hold, Member* Member_Hold)
{
	string _bar_code, bar_code;
	string _library_number, library_number;
	HoldEvent *temp_holdEvent;
	
	bar_code = Video_Hold->GetBarcodeNumber();
	library_number = Member_Hold->GetLibraryNumber();

	for (int i =0; i<_All_Current_Hold_Events.size(); i++)
	{
		temp_holdEvent = &_All_Current_Hold_Events[i];

		_library_number = temp_holdEvent->GetMember()->GetLibraryNumber();
		
		if (temp_holdEvent->GetVideo!=NULL)
			_bar_code = temp_holdEvent->GetVideo()->GetBarcodeNumber();

		if ( (_bar_code== bar_code) && (_library_number == library_number) )
			return &_All_Current_Hold_Events[i];
	}
	return NULL;
}


void HoldItems::Cancel(HoldEvent* Hold_event)
{
	_All_Current_Hold_Events.erase(Hold_event);	
}

