#ifndef HOLDITEMS_H
#define HOLDITEMS_H

#include <string>
#include <vector>
#include "HoldEvent.h"
using namespace std;

class HoldItems
{
public:

	HoldItems();
	//---The current Holds is undefined---
	// Pre :True
	// Post:True
	
	void Hold(HoldEvent* hold_event);
	//---Add a new hold to library collection of holds----
	// Pre :hold_event!=NULL
	// Post:_All_Current_Hold_Events'=_All_Current_Hold_Events+1 &&(ItemHold IsIn HoldEvent)

	
	HoldEvent* GetHoldEvent(Book* Book_Hold, Member* Member_Hold);
	//---takes a pointer to the Book and Member as parameters and create a hold event between Book object and Member object---
	// Pre: Book_Hold!=NULL && Member_Hold!=NULL && Book_Hold->OnHold()==false
	// Post:(Book_Hold->OnHold==true && Member_Hold->Output() INCLUDES *Book_Hold
	//  	    && return _All_Current_Hold_Events)
	//		OR 
	//  	   return NULL


	HoldEvent* GetHoldEvent(CD* CD_Hold, Member* Member_Hold);
	//---takes a pointer to the CD and Member as parameters and create a hold event between CD object and Member object---
	// Pre: CD_Hold!=NULL && Member_Hold!=NULL && CD_Hold->OnHold()==false
	// Post:(CD_Hold->OnHold==true && Member_Hold->Output() INCLUDES *CD_Hold
	//  	    && return _All_Current_Hold_Events)
	//   	OR 
	//  	   return NULL

	HoldEvent* GetHoldEvent(Video* Video_Hold, Member* Member_Hold);
	//---takes a pointer to the Video and Member as parameters and create a hold event between Video object and Member object---
	// Pre: Video_Hold!=NULL && Member_Hold!=NULL && Video_Hold->OnHold()==false
	// Post: (Video_Hold->OnHold==true && Member_Hold->Output() INCLUDES *Video_Hold
	//		    && return _All_Current_Hold_Events)
	//		OR 
	// 			return NULL

	void Cancel(HoldEvent* Hold_event);
	//--- Holds for the items have been cancelled and all the hold events have been destroyed---
	// Pre :Hold_event!=NULL
	// Post:_All_Current_Hold_Events'=_All_Current_Hold_Events-1  && NOT(ItemHold IsIn HoldEvent)



private:
	vector <HoldEvent> _All_Current_Hold_Events;
};

#endif