#ifndef JOURNAL_H
#define JOURNAL_H

#include <string>
#include <vector>
#include "LibraryItem.h"
using namespace std;

// A class inherited from class LibraryItem to represent and 
// manipulate a Journal from Journal collection

class Journal:public LibraryItem
{
public:
	Journal();
	// ---The current journal is undefined. An empty Journal object has been created---
	// Pre   :True
	// Post  :True

	Journal(string title, string BarcodeNumber, string Editor_Name,string Table_of_Contents);
	//---Initialise all the member data and pass it as parameters---
	// Pre :True
	// Post:GetBarcodeNumber()==BarcodeNumber && GetTitle()==title && _Editor_Name=Editor_Name
	//      && _Table_of_Contents=Table_of_Contents

	string GetEditorName()const;
	//---The editor name has been returned as a string---
	// Pre   :True
	// Post  :return _Editor_Name & _Editor_Name'=_Editor_Name

	string GetTableofContents()const;
	//---The table of contents of the journal has been returned as a string---
	// Pre   :True
	// Post  :return _Table_of_Contents & _Table_of_Contents'=_Table_of_Contents


	void Output();
	//--- Output the journal on a single line ot standard output---
	// Pre   :A journal has been selected.
	// Post  :OUTPUTS(LibraryItem::Output()) && GetEditorName() && GetTableofContents()
private:
	string _Editor_Name;
	string _Table_of_Contents;
	vector<Journal> _Journal;
};

#endif
		