#ifndef JOURNALCOLLECTION_H
#define JOURNALCOLLECTION_H

#include <string>
#include <vector>
#include "Journal.h"
using namespace std;

enum journalsearch
{
	first_journal,
	_by_jour_title,
	_by_jour_editor,
	last_journal
};

class JournalCollection
{
public:
	JournalCollection();
	//---The current collection of journal is undefined--- 
	// Pre :True
	// Post:True
 

	void AddJournal(string journal_title, string journal_barcode_num, string editor_name,string table_of_contents);
	//--- This function adds a new journal to the JournalCollection---
	// Pre   :journal_title,journal_barcode_num,editor_name,table_of_contents!=NULL
	// Post  :newJournal IsIn JournalCollection
	
	void RemoveJournal(string journal_barcode);
	//---Remove a journal by its barcode number, if the barcode match, the journal is removed---
	// Pre   :True
	// Post  :Journal->GetBarcodeNumber()==journal_barcode && NOT(Journal IsIn JournalCollection)


	JournalCollection *GetJournalByEditor(string editor);
	// ---Search a journal by its barcode number, if the barcode match, return a pointer to the Journal else return NULL---
	// Pre   :True
	// Post  :Journal->GetEditorName() == editor &&
    //		        (Journal IsIn JournalCollection &&
    //		        return Journal)
	//	      OR
    //		        return NULL

	Journal *GetJournalByBarcode(string journal_barcode);
	// ---Search a journal by its barcode number, if the barcode match, return a pointer to the Journal else return NULL---
	// Pre   :True
	// Post  :Journal->GetBarcodeNumber() == journal_barcode &&
    //			    (Journal IsIn JournalCollection &&
    //              return Journal)
	//	      OR
    //              return NULL

	JournalCollection *GetJournalByTitle(string title);
	//---Search a journal by its name, if the name matched, return a pointer to the JournalCollection else return NULL---
	// Pre   :True
	// Post  :Journal->GetTitle() == title &&
    //              (Journal IsIn JournalCollection &&
    //               return Journal)
	//		  OR
    //              return NULL

	void Output()const;
	//---To display all the journal details on the standard output---
	// Pre   :True
	// Post  :for_all Journal, Journal IsIn JournalCollection : OUTPUT Journal

private:
	vector <Journal> _All_Journal;
};

#endif
