#include <iostream>
#include <string>
#include <assert.h>
#include "Library.h"


using namespace std;


Library::Library()
{
	_library_members = new Membership;
	_library_books = new BookCollection;
	_library_cds = new CDCollection;
	_library_journals = new JournalCollection;
	_library_videos = new VideoCollection;

	_current_loan_event = new LoanEvent;
	_current_hold_event = new HoldEvent;
	_loan_events = new Loans;
	_hold_events = new HoldItems;

	_current_member = new Member;
	_current_book = NULL;
	_current_cd =  NULL;
	_current_video = NULL;
}


// convert char* to string
string convertChar(char *characters)
{
	int n =0;
	string _string;
	while ( (characters[n]) != '\0')
	{
		_string = _string + characters[n];
		n++;
	}
	return _string;
}



void Library::BorrowItem()
{
	if (_current_member == NULL)
	{
		cout << "A MEMBER MUST BE SELECTED BEFORE BORROW AN ITEM!" <<endl;
		return;
	}

	if (_current_book != NULL)
		BorrowBook();

	if (_current_cd != NULL)
		BorrowCD();

	if (_current_video != NULL)
		BorrowVideo();

	if ( (_current_book == NULL) && (_current_cd == NULL) && (_current_video == NULL) )
	{
		cout << "ITEM NOT FOUND!" << endl;
		return;
	}
	_current_book = NULL;
	_current_cd = NULL;
	_current_video = NULL;
}



void Library::BorrowBook()	
{
	if (!_current_book->OnLoan())
	{
		if (!_current_member->IsLoansOverdue())
		{
			if (!_current_book->OnHold())
			{
				LoanEvent* temp_loan_event = new LoanEvent(_current_book, _current_member);
				_current_member->Borrow(temp_loan_event);
				_current_book->Lend(temp_loan_event);
				_loan_events->Loan(temp_loan_event);
				_current_member->Output();
			}
			else
			{
				if ( (_current_member->GetName()) == (_current_book->GetBookHoldEvent()->GetMember()->GetName()) )
				{
					LoanEvent* temp_loan_event = new LoanEvent(_current_book, _current_member);
					_current_member->Borrow(temp_loan_event);
					_current_book->Lend(temp_loan_event);
					_loan_events->Loan(temp_loan_event);
					_current_member->Output();
				
					_current_book->CancelHold();
					_current_member->CancelHold(_current_book->GetBarcodeNumber());
					_hold_events->Cancel(_hold_events->GetHoldEvent(_current_book, _current_member));
				}
				else
				{
					cout << "BORROWER CANNOT BORROW THIS BOOK BECAUSE : "<< endl;
					cout << "                       THIS BOOK HOLD BY OTHER MEMBER !" << endl;
					cout << "SIMILAR TITLE THAT AVAILABLE IN LIBRARY : " << endl;
					BookCollection *temp_book_collection; 
					temp_book_collection = _library_books->GetHoldFreeBookByTitle(_current_book->GetTitle());
				
					if (temp_book_collection == NULL)
						cout << "ERROR! ALL COPIES OF THIS BOOK ARE CURRENTLY ON HOLD!" << endl;
					else
						temp_book_collection->Output();
				}
			}
		}
		else
			cout << "PLEASE RETURN OVERDUE ITEM BEFORE BORROW ANOTHER ITEM!" << endl;
	}
	else 
	{
		cout << "BORROWER CANNOT BORROW THIS BOOK BECAUSE : "<< endl;
		cout << "                       THIS BOOK BORROWED BY OTHER MEMBER !" << endl;
		cout << "SIMILAR TITLE THAT AVAILABLE IN LIBRARY : " << endl;
		BookCollection *temp_book_collection; 
		temp_book_collection = _library_books->GetHoldFreeBookByTitle(_current_book->GetTitle());
		
		if (temp_book_collection == NULL)
			cout << "ERROR! ALL COPIES OF THIS BOOK ARE CURRENTLY ON HOLD!"<< endl;
		else
			temp_book_collection->Output();
	}
}



void Library::BorrowCD()
{
	if (!_current_cd->OnLoan())
	{
		if (!_current_member->IsLoansOverdue())
		{
			if (!_current_cd->OnHold())
			{
				LoanEvent* temp_loan_event = new LoanEvent(_current_cd, _current_member);
				_current_member->Borrow(temp_loan_event);
				_current_cd->Lend(temp_loan_event);
				_loan_events->Loan(temp_loan_event);
				_current_member->Output();
			}
			else
			{
				if ( (_current_member->GetName()) == (_current_cd->GetCDHoldEvent()->GetMember()->GetName()) )
				{
					LoanEvent* temp_loan_event = new LoanEvent(_current_cd, _current_member);
					_current_member->Borrow(temp_loan_event);
					_current_cd->Lend(temp_loan_event);
					_loan_events->Loan(temp_loan_event);
					_current_member->Output();	
					
					_current_cd->CancelHold();
					_current_member->CancelHold(_current_cd->GetBarcodeNumber());
					_hold_events->Cancel(_hold_events->GetHoldEvent(_current_cd, _current_member));
				}
				else
				{
					cout << "BORROWER CANNOT BORROW THIS CD BECAUSE : "<< endl;
					cout << "                       THIS CD HOLD BY OTHER MEMBER !" << endl;
					cout << "SIMILAR TITLE THAT AVAILABLE IN LIBRARY : " << endl;
					CDCollection *temp_cd_collection; 
					temp_cd_collection = _library_cds->GetHoldFreeCDByTitle(_current_cd->GetTitle());
				
					if (temp_cd_collection == NULL)
						cout << "ERROR! ALL COPIES OF THIS CD ARE CURRENTLY ON HOLD!"<< endl;
					else
						temp_cd_collection->Output();
				}
			}
		}
		else 
			cout << "PLEASE RETURN OVERDUE ITEM BEFORE BORROW ANOTHER ITEM!" << endl;
	}
	else 
	{
		cout << "BORROWER CANNOT BORROW THIS CD BECAUSE : "<< endl;
		cout << "                       THIS CD BORROWED BY OTHER MEMBER !" << endl;
		cout << "SIMILAR TITLE THAT AVAILABLE IN LIBRARY : " << endl;
		CDCollection *temp_cd_collection; 
		temp_cd_collection = _library_cds->GetHoldFreeCDByTitle(_current_cd->GetTitle());
		
		if (temp_cd_collection == NULL)
			cout << "ERROR! ALL COPIES OF THIS CD ARE CURRENTLY ON HOLD!"<< endl;
		else
			temp_cd_collection->Output();
	}
}



void Library::BorrowVideo()
{
	if (!_current_video->OnLoan())
	{
		if (!_current_member->IsLoansOverdue())
		{
			if (!_current_video->OnHold())
			{
				LoanEvent* temp_loan_event = new LoanEvent(_current_video, _current_member);
				_current_member->Borrow(temp_loan_event);
				_current_video->Lend(temp_loan_event);
				_loan_events->Loan(temp_loan_event);
			}
			else
			{
				if ( (_current_member->GetName()) == (_current_video->GetVideoHoldEvent()->GetMember()->GetName()) )
				{
					LoanEvent* temp_loan_event = new LoanEvent(_current_video, _current_member);
					_current_member->Borrow(temp_loan_event);
					_current_video->Lend(temp_loan_event);
					_loan_events->Loan(temp_loan_event);

					_current_video->CancelHold();
					_current_member->CancelHold(_current_video->GetBarcodeNumber());
					_hold_events->Cancel(_hold_events->GetHoldEvent(_current_video, _current_member));
				}
				else
				{
					cout << "BORROWER CANNOT BORROW THIS VIDEO BECAUSE : "<< endl;
					cout << "                       THIS VIDEO HOLD BY OTHER MEMBER !" << endl;
					cout << "SIMILAR TITLE THAT AVAILABLE IN LIBRARY : " << endl;
					VideoCollection *temp_video_collection; 
					temp_video_collection = _library_videos->GetHoldFreeVideoByTitle(_current_video->GetTitle());
				
					if (temp_video_collection == NULL)
						cout << "ERROR! ALL COPIES OF THIS VIDEO ARE CURRENTLY ON HOLD!"<< endl;
					else
						temp_video_collection->Output();
				}
			}
		}
		else
			cout << "PLEASE RETURN OVERDUE ITEM BEFORE BORROW ANOTHER ITEM!" << endl;
	}
	else 
	{
		cout << "BORROWER CANNOT BORROW THIS VIDEO BECAUSE : "<< endl;
		cout << "                       THIS VIDEO BORROWED BY OTHER MEMBER !" << endl;
		cout << "SIMILAR TITLE THAT AVAILABLE IN LIBRARY : " << endl;
		VideoCollection *temp_video_collection; 
		temp_video_collection = _library_videos->GetHoldFreeVideoByTitle(_current_video->GetTitle());
		
		if (temp_video_collection == NULL)
			cout << "ERROR! ALL COPIES OF THIS VIDEO ARE CURRENTLY ON HOLD!";
		else
			temp_video_collection->Output();
	}
}



void Library::ReturnItem()
{
	if (_current_member == NULL)
	{
		cout << "A MEMBER MUST BE SELECTED BEFORE RETURN AN ITEM!" <<endl;
		return;
	}

	if (_current_book != NULL)
		ReturnBook();
	
	if (_current_cd != NULL)
		ReturnCD();

	if (_current_video != NULL)
		ReturnVideo();

	if ( (_current_book == NULL) && (_current_cd == NULL) && (_current_video == NULL) )
	{
		cout << "ITEM NOT FOUND!" << endl;
		return;
	}
	_current_book = NULL;
	_current_cd = NULL;
	_current_video = NULL;
}



void Library::ReturnBook()
{
	if (_current_book->OnLoan())
	{
		_current_book->Return();
		_current_member->Return(_current_book->GetBarcodeNumber());
		_loan_events->Return(_loan_events->GetLoanEvent(_current_book, _current_member));
		_current_member->Output();	
	}
	else
	{
		cout << "BORROWER CANNOT RETURN THIS BOOK BECAUSE : "<< endl;
		cout << "                       THIS BOOK IS NOT ON LOAN !" << endl;
	}
}




void Library::ReturnCD()
{
	if (_current_cd->OnLoan())
	{
		_current_cd->Return();
		_current_member->Return(_current_cd->GetBarcodeNumber());
		_loan_events->Return(_loan_events->GetLoanEvent(_current_cd, _current_member));
		_current_member->Output();	
	}
	else
	{
		cout << "BORROWER CANNOT RETURN THIS CD BECAUSE : "<< endl;
		cout << "                       THIS CD IS NOT ON LOAN !" << endl;
	}
}



void Library::ReturnVideo()
{
	if (_current_video->OnLoan())
	{
		_current_video->Return();
		_current_member->Return(_current_video->GetBarcodeNumber());
		_loan_events->Return(_loan_events->GetLoanEvent(_current_video, _current_member));
		_current_member->Output();	
	}
	else
	{
		cout << "BORROWER CANNOT RETURN THIS VIDEO BECAUSE : "<< endl;
		cout << "                       THIS VIDEO IS NOT ON LOAN !" << endl;
	}
}



void Library::HoldItem()
{
	if (_current_member == NULL)
	{
		cout << "A MEMBER MUST BE SELECTED BEFORE HOLD AN ITEM!" <<endl;
		return;
	}

	if (_current_book != NULL)
		HoldBook();
	
	if (_current_cd != NULL)
		HoldCD();

	if (_current_video != NULL)
		HoldVideo();

	if ( (_current_book == NULL) && (_current_cd == NULL) && (_current_video == NULL) )
	{
		cout << "ITEM NOT FOUND!" << endl;
		return;
	}
	_current_book = NULL;
	_current_cd = NULL;
	_current_video = NULL;

}



void Library::HoldBook()
{
	if (_current_member == NULL)
	{
		cout << "A MEMBER MUST BE SELECTED BEFORE HOLD AN ITEM!" <<endl;
		return;
	}

	if (!_current_book->OnHold())
	{
		if (!_current_member->IsLoansOverdue())
		{
			HoldEvent* temp_hold_event= new HoldEvent(_current_book, _current_member);
			_current_member->Hold(temp_hold_event);
			_current_book->Hold(temp_hold_event);
			_hold_events->Hold(temp_hold_event);
			_current_member->Output();	
		}
	}
	else
	{
		cout << "ERROR! BOOK HOLD BY OTHER MEMBER !" << endl;
		cout << "SIMILAR TITLE THAT AVAILABLE IN LIBRARY : " << endl;
		BookCollection *temp_book_collection; 
		temp_book_collection = _library_books->GetHoldFreeBookByTitle(_current_book->GetTitle());
	
		if (temp_book_collection == NULL)
			cout << "ERROR! ALL COPIES ARE CURRENTLY ON HOLD!";
		else
			temp_book_collection->Output();
	}
}



void Library::HoldCD()
{
	if (_current_member == NULL)
	{
		cout << "A MEMBER MUST BE SELECTED BEFORE HOLD AN ITEM!" <<endl;
		return;
	}

	if (!_current_cd->OnHold())
	{
		if (!_current_member->IsLoansOverdue())
		{
			HoldEvent* temp_hold_event= new HoldEvent(_current_cd, _current_member);
			_current_member->Hold(temp_hold_event);
			_current_cd->Hold(temp_hold_event);
			_hold_events->Hold(temp_hold_event);
			_current_member->Output();	
		}
	}
	else
	{
		cout << "ERROR! CD HOLD BY OTHER MEMBER !" << endl;
		cout << "SIMILAR TITLE THAT AVAILABLE IN LIBRARY : " << endl;
		CDCollection *temp_cd_collection; 
		temp_cd_collection = _library_cds->GetHoldFreeCDByTitle(_current_cd->GetTitle());
	
		if (temp_cd_collection == NULL)
			cout << "ERROR! ALL COPIES ARE CURRENTLY ON HOLD!";
		else
			temp_cd_collection->Output();
	}
}



void Library::HoldVideo()
{
	if (_current_member == NULL)
	{
		cout << "A MEMBER MUST BE SELECTED BEFORE HOLD AN ITEM!" <<endl;
		return;
	}

	if (!_current_video->OnHold())
	{
		if (!_current_member->IsLoansOverdue())
		{
			HoldEvent* temp_hold_event= new HoldEvent(_current_video, _current_member);
			_current_member->Hold(temp_hold_event);
			_current_video->Hold(temp_hold_event);
			_hold_events->Hold(temp_hold_event);
			_current_member->Output();	
		}
	}
	else
	{
		cout << "ERROR! VIDEO HOLD BY OTHER MEMBER !" << endl;
		cout << "SIMILAR TITLE THAT AVAILABLE IN LIBRARY : " << endl;
		VideoCollection *temp_video_collection; 
		temp_video_collection = _library_videos->GetHoldFreeVideoByTitle(_current_video->GetTitle());
	
		if (temp_video_collection == NULL)
			cout << "ERROR! ALL COPIES ARE CURRENTLY ON HOLD!";
		else
			temp_video_collection->Output();
	}
}



void Library::CancelHoldItem()
{
	if (_current_member == NULL)
	{
		cout << "A MEMBER MUST BE SELECTED BEFORE CANCEL THE HOLD FOR AN ITEM!" <<endl;
		return;
	}

	if (_current_book != NULL)
		CancelHoldBook();
	
	if (_current_cd != NULL)
		CancelHoldCD();

	if (_current_video != NULL)
		CancelHoldVideo();
	
	if ( (_current_book == NULL) && (_current_cd == NULL) && (_current_video == NULL) )
	{
		cout << "ITEM NOT FOUND!" << endl;
		return;
	}
	_current_book = NULL;
	_current_cd = NULL;
	_current_video = NULL;
}



void Library::CancelHoldBook()
{
	if (_current_book->OnHold())
	{
		_current_book->CancelHold();
		_current_member->CancelHold(_current_book->GetBarcodeNumber());
		_hold_events->Cancel(_hold_events->GetHoldEvent(_current_book, _current_member));
		_current_member->Output();	
	}
	else
	{
		cout << "BORROWER CANNOT CANCEL HOLD FOR THIS BOOK BECAUSE : "<< endl;
		cout << "                                THIS BOOK IS NOT ON HOLD !" << endl;
	}
}



void Library::CancelHoldCD()
{
	if (_current_cd->OnHold())
	{
		_current_cd->CancelHold();
		_current_member->CancelHold(_current_cd->GetBarcodeNumber());
		_hold_events->Cancel(_hold_events->GetHoldEvent(_current_cd, _current_member));
		_current_member->Output();	
	}
	else
	{
		cout << "BORROWER CANNOT CANCEL HOLD FOR THIS CD BECAUSE : "<< endl;
		cout << "                                THIS CD IS NOT ON HOLD !" << endl;
	}
}



void Library::CancelHoldVideo()
{
	if (_current_video->OnHold())
	{
		_current_video->CancelHold();
		_current_member->CancelHold(_current_video->GetBarcodeNumber());
		_hold_events->Cancel(_hold_events->GetHoldEvent(_current_video, _current_member));
		_current_member->Output();	
	}
	else
	{
		cout << "BORROWER CANNOT CANCEL HOLD FOR THIS VIDEO BECAUSE : "<< endl;
		cout << "                                THIS VIDEO IS NOT ON HOLD !" << endl;
	}
}



void Library::SelectMember()
{	
	cout << "SELECT/SEARCH MEMBER" << endl;
	cout << "====================" << endl;
	cout << "1. Select member through library card number" << endl;
	cout << "2. Select member through name" << endl;
	cout << "3, Search member through library card number" << endl;
	cout << "4, Search member through name" << endl;
	cout << "5, Back to main menu " <<endl;
	cout << "Selection : ";
	
	int selection, library_number;
	string member_name;	
	char *name = new char();
	cin.sync();
	cin >> selection;
	cout << endl;

	switch(selection)
	{
		case 1:
			cout << "Library card number : ";
			cin.sync();
			cin >> library_number;		
			_current_member = _library_members->GetMember(library_number);
			if (_current_member == NULL)
				cout << "MEMBER NOT FOUND!" << endl;
			break;

		case 2:
			cout << "Member's name : ";
			cin.sync();
			cin.getline(name, 50);
			member_name = convertChar(name);

			_current_member = _library_members->GetMember(member_name);
			if (_current_member == NULL)
				cout << "MEMBER NOT FOUND!" << endl;
			break;

		case 3:
			cout << "Library card number : ";
			cin.sync();
			cin >> library_number;		
			_current_member = _library_members->GetMember(library_number);
			this->DisplayMemberInfo();
			if (_current_member == NULL)
				cout << "MEMBER NOT FOUND!" << endl;
			break;

		case 4:
			cout << "Member's name : ";
			cin.sync();
			cin.getline(name, 50);
			member_name = convertChar(name);

			_current_member = _library_members->GetMember(member_name);
			this->DisplayMemberInfo();
			if (_current_member == NULL)
				cout << "MEMBER NOT FOUND!" << endl;
			break;	

		case 5:
			this->DisplayMainMenu();
			break;

		default:
			this->DisplayMainMenu();
			break;
	}
}



void Library::SelectItem()
{
	cout << "SELECT ITEM" << endl;
	cout << "=============" << endl;
	
	cout << "Please enter the bar code number : ";

	char* bar_code = new char();
	string barcode;
	cin.sync();
	cin.getline(bar_code, 50);
	barcode = convertChar(bar_code);

	_current_book = _library_books->GetBookByBarcode(barcode);
	_current_cd = _library_cds->GetCDByBarcode(barcode);
	_current_video = _library_videos->GetVideoByBarcode(barcode);

	if ( (_current_book == NULL) && (_current_cd == NULL) && (_current_video == NULL) )
	{
		cout << "ITEM NOT FOUND!" << endl;
		return;
	}
}



void Library::SearchBook()
{
	cout << "SEARCH BOOK" << endl;
	cout << "=============" << endl;
	cout << "1. Search book through bar code" << endl;
	cout << "2. Search book through title" << endl;
	cout << "3. Search book through author" << endl << endl;
	cout << "Selection : ";

	char hold;
	int selection;
	char* _barcode = new char();
	char* _title = new char();
	char* _name = new char();
	string bar_code, title, name;
	BookCollection* temp_book_collection;
	temp_book_collection = NULL;

	cin.sync();
	cin >> selection;
	
	switch(selection)
	{
		case 1:
			cout << "Please enter book's bar code number : ";
			cin.sync();
			cin.getline(_barcode, 50);
			bar_code = convertChar(_barcode);

			_current_book = _library_books->GetBookByBarcode(bar_code);
			if (_current_book == NULL)
			{
				cout << "Not Book Found!" << endl;
				return;
			}
			_current_book->Output();

			if (_current_book->OnLoan())
			{
				cout << "Book loan due date : ";
				_current_book->GetLoanDueDate()->Output();
				cout << endl;
			}
			cout << "Do you want to hold this book (y/n)?" << endl;
			cin.sync();
			cin >> hold;

			if (hold == 'y')
				this->HoldBook();

			break;

		case 2:
			cout << "Please enter book's title : ";
			cin.sync();
			cin.getline(_title, 50);		
			title = convertChar(_title);

			temp_book_collection = _library_books->GetBookByTitle(title);
			if (temp_book_collection == NULL)
			{
				cout << "Not Book Found!" << endl;
				return;
			}
			temp_book_collection->Output();


			cout << "Do you want to hold this book (y/n)?" << endl;
			cin.sync();
			cin >> hold;

			if (hold == 'y')
			{
				cout << "Please enter the book's bar code to be hold : ";
				cin.sync();
				cin.getline(_barcode, 50);	
				bar_code = convertChar(_barcode);

				_current_book = _library_books->GetBookByBarcode(bar_code);
				if (_current_book == NULL)
					cout << "BOOK NOT FOUND!" << endl;
				else
					this->HoldBook();
			}
			break;

		case 3:
			cout << "Please enter Author's name : ";
			cin.sync();
			cin.getline(_name, 50);		
			name = convertChar(_name);

			temp_book_collection = _library_books->GetBookByAuthor(name);
			
			if (temp_book_collection == NULL)
			{
				cout << "Not Book Found!" << endl;
				return;
			}
			temp_book_collection->Output();

			cout << "Do you want to hold this book (y/n)?" << endl;
			cin.sync();
			cin >> hold;

			if (hold == 'y')
			{
				cout << "Please enter the book's bar code to be hold : ";
				cin.sync();
				cin.getline(_barcode, 50);	
				bar_code = convertChar(_barcode);

				_current_book = _library_books->GetBookByBarcode(bar_code);
				if (_current_book == NULL)
					cout << "BOOK NOT FOUND!" << endl;
				else
					this->HoldBook();
			}
			break;
	}
}



void Library::SearchCD()
{
	cout << "SELECT CD" << endl;
	cout << "=============" << endl;
	cout << "1. Select cd through bar code" << endl;
	cout << "2. Select cd through title" << endl;
	cout << "3. Select cd through artist" << endl << endl;
	cout << "Selection : ";
	
	char hold;
	int selection;
	string bar_code, title, name;
	char* _barcode = new char();
	char* _title = new char();
	char* _name = new char();

	CDCollection* temp_cd_collection;
	temp_cd_collection = NULL;
	cin.sync();
	cin >> selection;

	switch(selection)
	{
		case 1:
			cout << "Please enter CD's bar code number : ";
			cin.sync();
			cin.getline(_barcode, 50);
			bar_code = convertChar(_barcode);
			
			_current_cd = _library_cds->GetCDByBarcode(bar_code);
			if (_current_cd == NULL)
				cout << "Not Book Found!" << endl;
			if (_current_cd->OnLoan())
			{
				cout << "CD loan due date : ";
				_current_cd->GetLoanDueDate()->Output();
				cout << endl;
			}

			cout << "Do you want to hold this CD (y/n)?" << endl;
			cin.sync();
			cin >> hold;

			if (hold == 'y')
				this->HoldCD();
			break;

		case 2:
			cout << "Please enter CD's title : ";
			cin.sync();
			cin.getline(_title, 50);		
			title = convertChar(_title);

			temp_cd_collection = _library_cds->GetCDByTitle(title);

			if (temp_cd_collection == NULL)
			{
				cout << "Not CD Found!" << endl;
				return;
			}

			temp_cd_collection->Output();

			cout << "Do you want to hold this CD (y/n)?" << endl;
			cin.sync();
			cin >> hold;

			if (hold == 'y')
			{
				cout << "Please enter the CD's bar code to be hold : ";
				cin.sync();
				cin.getline(_barcode, 50);	
				bar_code = convertChar(_barcode);

				_current_cd = _library_cds->GetCDByBarcode(bar_code);
				if (_current_cd == NULL)
					cout << "CD NOT FOUND!" << endl;
				else
					this->HoldCD();
			}
			break;

		case 3:
			cout << "Please enter Artist's name : ";
			cin.sync();
			cin.getline(_name, 50);		
			name = convertChar(_name);

			temp_cd_collection = _library_cds->GetCDByArtist(name);
			
			if (temp_cd_collection == NULL)
			{
				cout << "Not CD Found!" << endl;
				return;
			}

			temp_cd_collection->Output();

			cout << "Do you want to hold this CD (y/n)?" << endl;
			cin.sync();
			cin >> hold;

			if (hold == 'y')
			{
				cout << "Please enter the CD's bar code to be hold : ";
				cin.sync();
				cin.getline(_barcode, 50);	
				bar_code = convertChar(_barcode);

				_current_cd = _library_cds->GetCDByBarcode(bar_code);
				if (_current_cd == NULL)
					cout << "CD NOT FOUND!" << endl;
				else
					this->HoldCD();
			}
			break;
	}
}



void Library::SearchJournal()
{
	cout << "SELECT JOURNAL" << endl;
	cout << "=============" << endl;
	cout << "1. Select journal through bar code" << endl;
	cout << "2. Select journal through title" << endl;
	cout << "3. Select journal through editor" << endl << endl;
	cout << "Selection : ";
	
	int selection;
	string bar_code, title, editor;
	char* _barcode = new char();
	char* _title = new char();
	char* _name = new char();

	JournalCollection* temp_journal_collection;
	temp_journal_collection = NULL;
	cin.sync();
	cin >> selection;

	switch(selection)
	{
		case 1:
			cout << "Please enter journal's bar code number : ";
			cin.sync();
			cin.getline(_barcode, 50);
			bar_code = convertChar(_barcode);

			_current_journal = _library_journals->GetJournalByBarcode(bar_code);
			if (_current_journal == NULL)
				cout << "JOURNAL NOT FOUND!" << endl;
			break;

		case 2:
			cout << "Please enter journal's title : ";
			cin.sync();
			cin.getline(_title, 50);		
			title = convertChar(_title);

			temp_journal_collection = _library_journals->GetJournalByTitle(title);
			if (temp_journal_collection != NULL)
				temp_journal_collection->Output();
			break;

		case 3:
			cout << "Please enter editor's name : ";
			cin.sync();
			cin.getline(_name, 50);		
			editor = convertChar(_name);

			temp_journal_collection = _library_journals->GetJournalByEditor(editor);
			break;
	}
}



void Library::SearchVideo()
{
	cout << "SELECT VIDEO" << endl;
	cout << "=============" << endl;
	cout << "1. Select video through bar code" << endl;
	cout << "2. Select video through title" << endl;
	cout << "3. Select video through director" << endl << endl;
	cout << "Selection : ";
	
	char hold;
	int selection;
	string bar_code, title, director;
	char* _barcode = new char();
	char* _title = new char();
	char* _name = new char();
	
	VideoCollection* temp_video_collection;
	temp_video_collection = NULL;
	cin.sync();
	cin >> selection;

	switch(selection)
	{
		case 1:
			cout << "Please enter video's bar code number : ";
			cin.sync();
			cin.getline(_barcode, 50);
			bar_code = convertChar(_barcode);
	
			_current_video = _library_videos->GetVideoByBarcode(bar_code);
			if (_current_video == NULL)
			{
				cout << "VIDEO NOT FOUND!" << endl;
				return;
			}

			cout << "Do you want to hold this Video (y/n)?" << endl;
			cin.sync();
			cin >> hold;

			if (hold == 'y')
				this->HoldVideo();
			break;

		case 2:
			cout << "Please enter video's title : ";
			cin.sync();
			cin.getline(_title, 50);		
			title = convertChar(_title);

			temp_video_collection = _library_videos->GetVideoByTitle(title);
			
			if (temp_video_collection == NULL)
			{
				cout << "Not Video Found!" << endl;
				return;
			}

			temp_video_collection->Output();

			cout << "Do you want to hold this Video (y/n)?" << endl;
			cin.sync();
			cin >> hold;

			if (hold == 'y')
			{
				cout << "Please enter the Video's bar code to be hold : ";
				cin.sync();
				cin.getline(_barcode, 50);	
				bar_code = convertChar(_barcode);

				_current_video = _library_videos->GetVideoByBarcode(bar_code);
				if (_current_video == NULL)
					cout << "Video NOT FOUND!" << endl;
				else
					this->HoldVideo();
			}
			break;

		case 3:
			cout << "Please enter director's name : ";
			cin.sync();
			cin.getline(_name, 50);		
			director = convertChar(_name);

			temp_video_collection = _library_videos->GetVideoByDirector(director);
			
			if (temp_video_collection == NULL)
			{
				cout << "Not Video Found!" << endl;
				return;
			}

			temp_video_collection->Output();

			cout << "Do you want to hold this Video (y/n)?" << endl;
			cin.sync();
			cin >> hold;

			if (hold == 'y')
			{
				cout << "Please enter the Video's bar code to be hold : ";
				cin.sync();
				cin.getline(_barcode, 50);	
				bar_code = convertChar(_barcode);

				_current_video = _library_videos->GetVideoByBarcode(bar_code);
				if (_current_video == NULL)
					cout << "Video NOT FOUND!" << endl;
				else
					this->HoldVideo();
			}
			break;
	}
}



void Library::DisplayMemberInfo()
{
	if (_current_member == NULL)
	{
		cout << "A MEMBER MUST BE SELECTED BEFORE BORROW AN ITEM!" <<endl;
		return;
	}
	_current_member->Output();
}



void Library::DisplayItemInfo()
{
	if (_current_book != NULL)
		_current_book->Output();
	
	if (_current_cd != NULL)
		_current_cd->Output();

	if (_current_video != NULL)
		_current_video->Output();

	if ( (_current_book == NULL) && (_current_cd == NULL) && (_current_video == NULL) )
	{
		cout << "ITEM NOT FOUND!" << endl;
		return;
	}
}



void Library::AddBook()
{
	char* _barcode = new char();
	char* _title = new char();
	char* _author = new char();
	int loan_length;
	string barcode, title, author;

	cout << "ADD NEW BOOK" << endl;
	cout << "============" << endl << endl;
	cout << "Barcode: ";
	cin.sync();
	cin.getline(_barcode,50);
	barcode = convertChar(_barcode);

	cout << "Title: ";
	cin.sync();
	cin.getline(_title, 50);
	title = convertChar(_title);

	cout << "Author: ";
	cin.sync();
	cin.getline(_author,50);
	author = convertChar(_author);

	cout << "Book's loan length (days): ";
	cin.sync();
	cin >> loan_length;

	_library_books->AddBook(_barcode, title, author, loan_length);
}



void Library::AddCD()
{
	char* _title = new char();
	char* _barcode = new char();
	char* _artist = new char();
	char* _playtime = new char();
	int loan_length;
	string barcode, title, artist, playtime;

	cout << "ADD NEW JOURNAL" << endl;
	cout << "===============" << endl << endl;
	cout << "Barcode: ";
	cin.sync();
	cin.getline(_barcode, 50);
	barcode = convertChar(_barcode);

	cout << "Title: ";
	cin.sync();
	cin.getline(_title, 50);
	title = convertChar(_title);

	cout << "Artist: ";
	cin.sync();
	cin.getline(_artist, 50);
	artist = convertChar(_artist);

	cout << "Play Time: ";
	cin.sync();
	cin.getline(_playtime, 50);
	playtime = convertChar(_playtime);

	cout << "CD's loan length (days): ";
	cin.sync();
	cin >> loan_length;

	_library_cds->AddCD(title, barcode, artist, playtime, loan_length);
}



void Library::AddJournal()
{
	char* _title = new char();
	char* _barcode = new char();
	char* _editor = new char();
	char* _TOB = new char();
	string barcode, title, editor, TOB;

	cout << "ADD NEW JOURNAL" << endl;
	cout << "===============" << endl << endl;
	cout << "Barcode: ";
	cin.sync();
	cin.getline(_barcode, 50);
	barcode = convertChar(_barcode);

	cout << "Title: ";
	cin.sync();
	cin.getline(_title, 50);
	title = convertChar(_title);

	cout << "Editor: ";
	cin.sync();
	cin.getline(_editor, 50);
	editor = convertChar(_editor);

	cout << "Table of content: ";
	cin.sync();
	cin.getline(_TOB, 150);
	TOB = convertChar(_TOB);

	_library_journals->AddJournal( title, barcode, editor, TOB);
}



void Library::AddVideo()
{
	char* _title = new char();
	char* _barcode = new char();
	char* _director = new char();
	char* _rating = new char();
	int loan_length;
	string barcode, title, director, rating;

	cout << "ADD NEW VIDEO" << endl;
	cout << "============" << endl << endl;
	cout << "Barcode: ";
	cin.sync();
	cin.getline(_barcode, 50);
	barcode = convertChar(_barcode);

	cout << "Title: ";
	cin.sync();
	cin.getline(_title, 50);
	title = convertChar(_title);

	cout << "Director: ";
	cin.sync();
	cin.getline(_director, 50);
	director = convertChar(_director);

	cout << "Rating: ";
	cin.sync();
	cin.getline(_rating, 20);
	rating = convertChar(_rating);

	cout << "Video's loan length (days): ";
	cin.sync();
	cin >> loan_length;

	_library_videos->AddVideo( title, barcode, director, rating, loan_length);
}



void Library::RemoveItem()
{
	string barcode;
	char* _barcode = new char();
	cout << "READING BARCODE OF THE ITEM TO BE DELETED: ";
	cin.sync();
	cin.getline(_barcode, 50);
	barcode = convertChar(_barcode);

	_current_book = _library_books->GetBookByBarcode(barcode);
	_current_journal = _library_journals->GetJournalByBarcode(barcode);
	_current_cd = _library_cds->GetCDByBarcode(barcode);
	_current_video = _library_videos->GetVideoByBarcode(barcode);

	if (_current_book != NULL)
		RemoveBook();
	
	if (_current_journal != NULL)
		RemoveJournal();

	_current_cd = _library_cds->GetCDByBarcode(barcode);
	if (_current_cd != NULL)
		RemoveCD();

	_current_video = _library_videos->GetVideoByBarcode(barcode);
	if (_current_video != NULL)
		RemoveVideo();
	
	if ( (_current_book == NULL) && (_current_cd == NULL) && (_current_video == NULL) )
	{
		cout << "ITEM NOT FOUND!" << endl;
		return;
	}

	_current_book = NULL;
	_current_journal = NULL;
	_current_cd = NULL;
	_current_video = NULL;
}



void Library::RemoveBook()
{
	_library_books->RemoveBook(_current_book->GetBarcodeNumber());
	cout << "BOOK HAS BEEN REMOVED!" << endl;
}



void Library::RemoveCD()
{
	_library_cds->RemoveCD(_current_cd->GetBarcodeNumber());
	cout << "CD HAS BEEN REMOVED!" << endl;
}



void Library::RemoveJournal()
{
	_library_journals->RemoveJournal(_current_journal->GetBarcodeNumber());
	cout << "JOURNAL HAS BEEN REMOVED!" << endl;
}



void Library::RemoveVideo()
{
	_library_videos->RemoveVideo(_current_video->GetBarcodeNumber());
	cout << "VIDEO HAS BEEN REMOVED!" << endl;
}



void Library::AddMember()
{
	char* _name = new char();
	char* _address = new char();
	char* _phone = new char();
	string name, address, phone, email;
	int library_number;

	cout << "ADD NEW MEMBER" << endl;
	cout << "==============" << endl << endl;
	cout << "Name: ";
	cin.sync();
	cin.getline(_name,50);
	name = convertChar(_name);

	cout << "Address: ";
	cin.sync();
	cin.getline(_address, 100);
	address = convertChar(_address);

	cout << "Phone number: ";
	cin.sync();
	cin.getline(_phone, 50);
	phone = convertChar(_phone);

	cout << "E-mail address: ";
	cin.sync();
	cin >> email;

	cout << "Library number: ";
	cin.sync();
	cin >> library_number;

	_library_members->AddMember( name, address, phone, email, library_number);
}



void Library::RemoveMember()
{
	if (_current_member == NULL)
	{
		cout << "A MEMBER MUST BE SELECTED BEFORE REMOVE THE MEMBER!" <<endl;
		return;
	}
	_library_members->RemoveMember(_current_member->GetLibraryNumber());
}


void Library::DisplayMemberWithOverdueItem()
{
	cout << "MEMBER WITH OVERDUE ITEM/ITEMS"<<endl;
	cout << "=============================="<<endl;
	
	// overdue books
	_library_books->DisplayMemberWithOverdueBooks();
	
	// overdue cds
	_library_cds->DisplayMemberWithOverdueCDs();

	//overdue video
	_library_videos->DisplayMemberWithOverdueVideos();
}

void Library::DisplayMainMenu()
{
	int selection = 0;
	for (;;)
	{
		cout << endl;
		cout << "Library System                                                " << endl;
		cout << "==============                                                " << endl ;
		cout << "Please select from the following :                            " << endl; 
		cout << " 1. Add a new member                8. Return item            " << endl;
		cout << " 2. Select/search member            9. Hold item              " << endl;
		cout << " 3. Delete a member                10. Cancel hold item       " << endl;
		cout << " 4. Display member's details       11. Display item's details " << endl;
		cout << " 5. Add/delete an item             12. Online catalog         " << endl;
		cout << " 6. Select item                    13. List of overdues       " << endl;
		cout << " 7. Borrow item                    14. Quit                   " << endl;
		cout << "selection : ";

		cin.sync();
		cin >> selection;
		cout << endl;
		switch(selection)
		{
			case 1:
				this->AddMember();
				break;
			case 2:
				this->SelectMember();
				break;
			case 3:
				this->RemoveMember();
				break;
			case 4:
				this->DisplayMemberInfo();
				break;
			case 5:
				this->AddItemMenu();
				break;
			case 6:
				this->SelectItem();
				break;
			case 7:
				this->BorrowItem();
				break;
			case 8:
				this->ReturnItem();
				break;
			case 9:
				this->HoldItem();
				break;
			case 10:
				this->CancelHoldItem();
				break;
			case 11:
				this->DisplayItemInfo();
				break;
			case 12:
				this->OnlineCatalog();
				break;
			case 13:
				this->DisplayMemberWithOverdueItem();
				break;
			case 14:
				return;
				break;
			default:
				this->DisplayMainMenu();
				break;
		};
	}
}



void Library::AddItemMenu()
{
	int exit =0;
	do
	{
		cout << endl;
		cout << "Add/Delete item                               "<< endl;
		cout << "===============                               "<< endl; 
		cout << "Please select from the following :                            " << endl;
		cout << " 1. Add Book                        5. Remove Item            " << endl;
		cout << " 2. Add CD                          6. Return to main menu    " << endl;
		cout << " 3. Add Journal                                               " << endl;
		cout << " 4. Add Video                                                 " << endl;
		cout << "                                                              " << endl;
		cout << "selection : ";
			
			int selection;
			cin.sync();
			cin >> selection;
			cout << endl;
			switch(selection)
			{
				case 1:
					this->AddBook();
					break;
				case 2:
					this->AddCD();
					break;
				case 3:
					this->AddJournal();
					break;
				case 4:
					this->AddVideo();
					break;
				case 5:
					this->RemoveItem();
					break;
				case 6:
					this->DisplayMainMenu();
					break;
				default:
					this->AddItemMenu();
					break;
			};
	} while (exit!=1);
}

void Library::OnlineCatalog()
{
	cout << "Library Online Catalog" << endl;
	cout << "======================" << endl << endl;
	cout << "1, Search Book        " << endl;
	cout << "2, Search CD          " << endl;
	cout << "3, Search Journal     " << endl;
	cout << "4, Search Video       " << endl;
	cout << "5, Back to main menu  " << endl;
	int selection;
	cin.sync();
	cin >> selection;
	cout << endl;
	switch(selection)
	{
		case 1:
			this->SearchBook();
			break;
		case 2:
			this->SearchCD();
			break;
		case 3:
			this->SearchJournal();
			break;
		case 4:
			this->SearchVideo();
			break;
		case 5:
			this->DisplayMainMenu();
			break;
		default:
			this->OnlineCatalog();
	}
}


