#ifndef LOANEVENT_H
#define LOANEVENT_H

#include "Member.h"
#include "Book.h"
#include "Video.h"
#include "CD.h"
using namespace std;

class CD;
class Video;
class Book;
class Member;
class LoanEvent
{
public:
	LoanEvent();
	//---create an empty LoanEvent object---
	//Pre: True
	//Post:True

	LoanEvent(Book *Book_Loan, Member *Member_Loan);
	//---A constructor to initialise the member data and passed the pointer to Book and Member as parameters---
	// Pre :Book_Loan!=NULL && Member_Loan!=NULL
	// Post:Book_Loan->OnLoan()==true && CD_Loan=NULL && Video_Loan=NULL
	
	LoanEvent(CD *CD_Loan, Member *Member_Loan);
	//---A constructor to initialise the member data and passed the pointer to CD and Member as parameters---
	// Pre :CD_Loan!=NULL && Member_Loan!=NULL
	// Post:CD_Loan->OnLoan()==true && Book_Loan=NULL && Video_Loan=NULL
	
	LoanEvent(Video *Video_Loan, Member *Member_Loan);
	//---A constructor to initialise the member data and passed the pointer to Video and Member as parameters---
	// Pre :Video_Loan!=NULL && Member_Loan!=NULL
	// Post:Video_Loan->OnLoan()==true && CD_Loan=NULL && Book_Loan=NULL
		
	Book *GetBook();
	//---return a pointer involved in the loan to Book---
	// Pre :True
	// Post:returns _Book_Involved_In_Loan

	Member *GetMember();
	//---return a pointer to the member involved in the loan to Member---
	// Pre :True
	// Post:returns _Member_Involved_In_Loan

	CD *GetCD();
	//---return a pointer to the CD involved in the loan to CD---
	// Pre :True
	// Post:returns _CD_Involved_In_Loan


	Video *GetVideo();
	//---return a pointer to the video involved in the loan to Video---
	// Pre :True
	// Post:returns _Video_Involved_In_Loan

	void Output()const;
	//---Display the details of all the items involved in the loan---
	// Pre : True
	// Post : OUTPUTS ( details of the items involved in loan)

private:
	Book *Book_Involved_In_Loan;
	Member *Member_Involved_In_Loan;
	CD *CD_Involved_In_Loan;
	Video *Video_Involved_In_Loan;


};

#endif
