#ifndef LOANS_H
#define LOANS_H

#include <string>
#include <vector>
#include "LoanEvent.h"
using namespace std;

class Loans
{
public:
	Loans();
	//---The current Loans is undefined---
	// Pre :True
	// Post:True
	
	void Loan(LoanEvent *loan_event);
	//---Add a new loan to library collection of loans---
	// Pre :loan_event!=NULL
	// Post:_All_Loan_Event'=_All_Loan_Event+1 && (ItemLoan IsIn LoanEvent)

	LoanEvent* GetLoanEvent(Book *Book_Loan, Member *Member_Loan);
	//---takes a pointer to the Book and Member as parameters and create a loan event between Book object and Member object---
	// Pre: Book_Loan!=NULL && Member_Loan!=NULL && Book_Loan->OnLoan()==false
	// Post: (Book_Loan->OnLoan==true && Member_Loan->Output() INCLUDES *Book_Loan
	//		    && return _All_Loan_Event )
	//		OR 
	//		   return NULL

	LoanEvent* GetLoanEvent(CD *CD_Loan, Member *Member_Loan);
	//---takes a pointer to the CD and Member as parameters and create a loan event between CD object and Member object---
	// Pre: CD_Loan!=NULL && Member_Loan!=NULL && CD_Loan->OnLoan()==false
	// Post: (CD_Loan->OnLoan==true && Member_Loan->Output() INCLUDES *CD_Loan
	//			&& return _All_Loan_Event )
	//		OR 
	//		   return NULL

	LoanEvent* GetLoanEvent(Video *Video_Loan, Member *Member_Loan);
	//---takes a pointer to the Video and Member as parameters and create a loan event between Video object and Member object---
	// Pre: Video_Loan!=NULL && Member_Loan!=NULL && Video_Loan->OnLoan()==false
	// Post: (Video_Loan->OnLoan==true && Member_Loan->Output() INCLUDES *Video_Loan
	//			&& return _All_Loan_Event )
	//		OR 
	//		   return NULL

	void Return(LoanEvent *loan_event);
	//--- Items have been returned and all the loan event has been destroyed---
	// Pre :loan_event!=NULL
	// Post:_All_Loan_Event'=_All_Loan_Event-1 && NOT (ItemLoan IsIn LoanEvent)

private:
	vector <LoanEvent> _All_Loan_Event;
};

#endif