#include <iostream>
#include "Member.h"
using namespace std;



Member::Member()
{

}


Member::Member(string Member_Name, string Address, string Phone_Number, string E_Mail, int Member_Library_Number): 
_Member_Name(Member_Name),_Address(Address),_Phone_Number(Phone_Number),_E_Mail(E_Mail),_Member_Library_Number(Member_Library_Number)
{

}


string Member::GetName()
{
	return _Member_Name;
}


int Member::GetLibraryNumber()
{
	return _Member_Library_Number;
}


void Member::Borrow(LoanEvent *A_Member_Loan)
{
	_LoanEvent_For_A_Member.push_back(*A_Member_Loan);
}


void Member::Return(string barcode)
{
	string bar_code;
	
	for (int i=0; i<_LoanEvent_For_A_Member.size(); i++)
	{
	
		bar_code = _LoanEvent_For_A_Member[i].GetBook()->GetBarcodeNumber();
		if (bar_code == barcode)
			_LoanEvent_For_A_Member.erase(&_LoanEvent_For_A_Member[i]);
	}
}


void Member::Hold(HoldEvent *hold_event)
{
	_HoldEvent_For_A_Member.push_back(*hold_event);
}


void Member::CancelHold(string barcode)
{
	string bar_code;
	
	for (int i=0; i<_HoldEvent_For_A_Member.size(); i++)
	{
		bar_code = _HoldEvent_For_A_Member[i].GetBook()->GetBarcodeNumber();
		if (bar_code == barcode)
			_HoldEvent_For_A_Member.erase(&_HoldEvent_For_A_Member[i]);
	}
}


bool Member::IsLoansOverdue()
{
	for (int i=0; i<_LoanEvent_For_A_Member.size(); i++)
	{
		if (_LoanEvent_For_A_Member[i].GetBook()!=NULL)
			if (_LoanEvent_For_A_Member[i].GetBook()->IsLoanOverdue())
				return true;
		if (_LoanEvent_For_A_Member[i].GetCD()!=NULL)
			if (_LoanEvent_For_A_Member[i].GetCD()->IsLoanOverdue())
				return true;
		if (_LoanEvent_For_A_Member[i].GetVideo()!=NULL)
			if (_LoanEvent_For_A_Member[i].GetVideo()->IsLoanOverdue())
				return true;
	}
	return false;
}


LoanEvent* Member::GetMemberLoanEvent(Book* book)
{
	for (int i =0; i<_LoanEvent_For_A_Member.size(); i++)
		if( (_LoanEvent_For_A_Member[i].GetBook()->GetBarcodeNumber()) == (book->GetBarcodeNumber()) )
			return &_LoanEvent_For_A_Member[i];
	return NULL;
}

HoldEvent* Member::GetMemberHoldEvent(Book* book)
{
	for (int i =0; i<_HoldEvent_For_A_Member.size(); i++)
		if( (_HoldEvent_For_A_Member[i].GetBook()->GetBarcodeNumber()) == (book->GetBarcodeNumber()) )
			return &_HoldEvent_For_A_Member[i];
	return NULL;
}

LoanEvent* Member::GetMemberLoanEvent(CD* cd)
{
	for (int i =0; i<_LoanEvent_For_A_Member.size(); i++)
		if( (_LoanEvent_For_A_Member[i].GetCD()->GetBarcodeNumber()) == (cd->GetBarcodeNumber()) )
			return &_LoanEvent_For_A_Member[i];
	return NULL;
}

HoldEvent* Member::GetMemberHoldEvent(CD* cd)
{
	for (int i =0; i<_HoldEvent_For_A_Member.size(); i++)
		if( (_HoldEvent_For_A_Member[i].GetCD()->GetBarcodeNumber()) == (cd->GetBarcodeNumber()) )
			return &_HoldEvent_For_A_Member[i];
	return NULL;
}

LoanEvent* Member::GetMemberLoanEvent(Video* video)
{
	for (int i =0; i<_LoanEvent_For_A_Member.size(); i++)
		if( (_LoanEvent_For_A_Member[i].GetVideo()->GetBarcodeNumber()) == (video->GetBarcodeNumber()) )
			return &_LoanEvent_For_A_Member[i];
	return NULL;
}

HoldEvent* Member::GetMemberHoldEvent(Video* video)
{
	for (int i =0; i<_HoldEvent_For_A_Member.size(); i++)
		if( (_HoldEvent_For_A_Member[i].GetVideo()->GetBarcodeNumber()) == (video->GetBarcodeNumber()) )
			return &_HoldEvent_For_A_Member[i];
	return NULL;
}

void Member::Output()
{	
	LoanEvent *temp_loanEvent;
	HoldEvent *temp_holdEvent;
	string title_from_vector, barcode;
	Book *temp_book;

	cout <<"===================" << endl;
	cout << "MEMBER         : " << _Member_Name << endl;
	cout << "Address        : " << _Address << endl;
	cout << "Phone Number   : " << _Phone_Number << endl;
	cout << "E_Mail Address : " << _E_Mail << endl;
	cout << "Library Number : " << _Member_Library_Number << endl << endl;

	for (int i=0; i<_LoanEvent_For_A_Member.size(); i++)
	{
		temp_loanEvent = &_LoanEvent_For_A_Member[i];
		temp_book = temp_loanEvent->GetBook();
		title_from_vector= temp_book->GetTitle();
		barcode = temp_book->GetBarcodeNumber();
		cout << "Books borrowed = "<< barcode << " " << title_from_vector 
			 << " " <<"Due date :"; 
		temp_book->GetLoanDueDate()->Output();
		if (temp_book->IsLoanOverdue())
			cout << "  OVERDUE!";
	}
	cout << endl;
	
	for (int n=0; n<_HoldEvent_For_A_Member.size(); n++)
	{
		temp_holdEvent = &_HoldEvent_For_A_Member[n];
		temp_book = temp_holdEvent->GetBook();
		title_from_vector= temp_book->GetTitle();
		barcode = temp_book->GetBarcodeNumber();
		cout << "Books hold     = "<< barcode << " " << title_from_vector 
			 << " " << "Due date :"; 
		temp_book->GetLoanDueDate()->Output();
		if (temp_book->IsLoanOverdue())
			cout << "  OVERDUE!";
	}
	cout << endl << "===================" << endl;
}