#ifndef MEMBERSHIP_H
#define MEMBERSHIP_H

#include <string>
#include <vector>
#include "Member.h"
using namespace std;

enum Search
{
	first_search,
	_name_search,
	_lib_num_search,
	last_search
};

class Membership
{
public:
	Membership();
	//---The current collection of member is undefined. A Membership object is created---
	// Pre :True
	// Post: The Membership object has been created

	void AddMember(string member_name,string _address,string phone_number,string e_mail,int library_number);
	//---Add a new member to the Membership----
	// Pre: member_name, _address,Phone_number,e_mail,library_number!=NULL
	// Post: newMember IsIn Membership

	void RemoveMember(int library_number);
	//---Remove a member by their library number from the Membership----
	// Pre   :True
	// Post  :Member->GetLibraryNumber()==library_number && NOT(Member IsIn Membership)


	Member *GetMember(string member_name);
	//---Search a member by their name---
	// Pre   :True
	// Post  :Member->GetName() == member_name &&
    //           (Member IsIn Membership &&
    //            return Member)
	//	  OR 
	//	      return NULL

	Member *GetMember(int library_number);
	//---To search a member by their library number---
	// Pre   :True
	// Post  :Member->GetLibraryNumber() == library_number &&
    //           (Member IsIn Membership &&
    //            return Member)
	//	      OR 
	//	         return NULL


	void Output() const;
	//---To display the details of al the members in the library to a standard output---
	// Pre :True
	// Post: for_all Member, Member IsIn Membership: OUTPUT Member
private:
	vector <Member> _All_Member;
};

#endif


