#include "Month.h"
#include <assert.h>
#include <iso646.h>
#include <iostream>
#include <iomanip>
using namespace std;


Month::Month()
{
}


Month::Month(int month_nr, int year_nr) 
 : _month_nr(month_nr), _year(year_nr)
{
    assert((Jan <= month_nr) and (month_nr <= Dec));
}


Month::Month(int month_nr, Year year) 
 : _month_nr(month_nr), _year(year)
{
    assert((Jan <= month_nr) and (month_nr <= Dec));
}


string Month::Name() const
{
    switch (_month_nr)
    {
        case Jan: return "January";
        case Feb: return "Febuary";
        case Mar: return "March";
        case Apr: return "April";
        case May: return "May";
        case Jun: return "June";
        case Jul: return "July";
        case Aug: return "August";
        case Sep: return "September";
        case Oct: return "October";
        case Nov: return "November";
        case Dec: return "December";
        default: return "";
    }
}


void Month::Output() const
{
	cout << "/" << _month_nr;
	_year.Output();
}


int Month::Days_in_month() const
{
    switch (_month_nr)
    {
    case Sep:
    case Apr:
    case Jun:
    case Nov:
        return 30;
    case Feb:
        {
        if (_year.Is_leap_year())
            return 29;
        else 
            return 28;
        }
    default:
        return 31;
    }
}


bool Month::Is_same_as(const Month &other_month) const
{
    return _year.Is_same_as(other_month._year) and
           (_month_nr == other_month._month_nr);
}


bool Month::Is_earlier_than(const Month &other_month) const
{
    return ( (!this->Is_later_than(other_month)) && (!this->Is_same_as(other_month)) );
}


bool Month::Is_later_than(const Month &other_month) const
{
    return _year.Is_later_than(other_month._year) or
           (_year.Is_same_as(other_month._year) and
            (_month_nr > other_month._month_nr));
}


Month Month::Next_month() const
{
    if (_month_nr < Dec)
        return Month((Months)(_month_nr+1), _year);
    else
        return Month(Jan, _year.Next_year());
}

