#include "Time.h"
#include <assert.h>
#include <iso646.h>
#include <string>
#include <iostream>
#include <iomanip>
using namespace std;


Time::Time()
{
}


Time::Time(int hour, int minute): _hour(hour), _minute(minute)
{
    assert((0 <= hour) and (hour < hours_per_day));
    assert((0 <= minute) and (minute < minutes_per_hour));
}


void Time::Output() const
{
   if (_hour > noon)
        cout << _hour - noon;
    else 
        cout << _hour;
    
    cout << ":" << _minute;
    
    if (_hour < noon) 
        cout << "am ";
    else
        cout << "pm ";
}


Time Time::Next_minute() const
{
    if (_minute+1 < minutes_per_hour)
        return Time(_hour, _minute+1);
    else
        return Time(_hour+1, 0);
}


bool Time::Is_same_as(const Time &other_time) const
{
    return (_hour == other_time._hour) and
           (_minute == other_time._minute);
}


bool Time::Is_earlier_than(const Time &other_time) const
{
    return ( (!this->Is_later_than(other_time)) && (!this->Is_same_as(other_time)) );
}


bool Time::Is_later_than(const Time &other_time) const
{
    return (_hour > other_time._hour) or
           ((_hour == other_time._hour) and
            (_minute > other_time._minute));
}


int Time::Minutes_till(const Time &future_time) const
{
    int minutes = 0;

    for (Time tmp = *this; 
         tmp.Is_earlier_than(future_time);
         tmp = tmp.Next_minute())
        minutes++;

    return minutes;
}

