#ifndef already_included_time
#define already_included_time

#include <iostream>
using namespace std;


// This class is designed to represent a time of day. Such a time is represented
// by the number of hours since midnight, plus the number of minutes past that 
// hour.

class Time
{
private:
    int _hour;
    int _minute;

public:
    Time();
	//---create a Time object---
	// Pre:  True
	// Post: True

    Time(int hour, int minute);
	//---Initialise all the member data and pass it as parameter to create a Time object---
    // Pre:  0 <= hour < 24 and 0 <= minute < 60
    // Post:Time object has been constructed

    void Output() const;
    // ---To output the details of the time such as whether it is pm or am---
    // Pre:  True
    // Post: OUTPUTS( details of the time)

    bool Is_same_as(const Time &other_time) const;
    //---to check whether the time is same as other_time and return true if and only if the time is same as other_time---
    // Pre:  True
    // Post: return (_hour'==other_time._hour) && (_minute'==other_time._minute)

    bool Is_earlier_than(const Time &other_time) const;
    //---to check whether the time is earlier than other_time and return true if and only if the time is earlier than other_time---
    // Pre:  True
    // Post: return (_hour'<other_time._hour) && (_minute'<other_time._minute)

    bool Is_later_than(const Time &other_time) const;
    //---to check whether the time is later than other_time and return true if and only if the time is later than other_time---
    // Pre:  True
    // Post: return (_hour'>other_time._hour) && (_minute'>other_time._minute)


    Time Next_minute() const;
   	// ---The Time of the minute immediately after the current time is
    //     returned. For example, the minute after 4:59 is 5:00---
    // Pre:  The time is earlier than the last minute of the day (23:59)
    // Post: return (_minute'==_minute+1 && _hour'==_hour) OR (_hour'==_hour+1 && _minute==0)

    int Minutes_till(const Time &future_time) const;
    //--- The number of minutes between the time and the future_time has
    //    been returned. If the time is the same as, or latter than the
    //    future_time, zero minutes is returned.
	// Pre:  True
    // Post: return (number_of_minutes) if and only if time is earlier than future_time

};
const int minutes_per_hour = 60;
const int hours_per_day = 24;
const int minutes_per_day = hours_per_day * minutes_per_hour;
const int noon = 12;

#endif