#include "Video.h"
#include <iostream>
using namespace std;


Video::Video() :LibraryItem()
{
	_Video_Loan = NULL;
	_hold_event = NULL;
	loan_due_date = new Clock(9999,1,1,1,1);
}


Video::Video(string title, string BarcodeNumber, string Director_Name, string rating, int loan_length):
LibraryItem(title, BarcodeNumber),_Director_Name(Director_Name), _rating(rating), _loan_length(loan_length)
{
	_Video_Loan = NULL;
	_hold_event = NULL;
	loan_due_date = new Clock(9999,1,1,1,1);
}	


void Video::Lend(LoanEvent *A_Video_Loan)
{	
	Clock temp_clock;
	loan_due_date = new Clock(temp_clock.GetPresentYear(),
							  temp_clock.GetPresentMonth(),
							  temp_clock.GetPresentDay() + _loan_length,
							  temp_clock.GetPresentHour(),
							  temp_clock.GetPresentMinute());
	_Video_Loan=A_Video_Loan;
}


void Video::Return()
{
	if(OnHold())
	{
		cout<< "PLEASE HOLD THIS VIDEO FOR 48 HOURS IN LIBRARY!"<<endl;
		cout<< "And notify member " << _hold_event->GetMember()->GetLibraryNumber() << " ";
		cout<< _hold_event->GetMember()->GetName() << endl;
	}
	if(this->IsLoanOverdue())
		cout <<"BOOK LOAN OVERDUE !"<< endl;
	_Video_Loan = NULL;
}


bool Video::OnLoan()
{
	if (_Video_Loan== NULL)
		return false;
	else 
		return true;
}


bool Video::OnHold()
{
	if (_hold_event == NULL)
		return true;
	else
		return false;
}


void Video::Hold(HoldEvent *Video_Hold_Event)
{
	Clock temp_clock;
	if (this->OnLoan())
	{
		loan_due_date = new Clock(temp_clock.GetPresentYear(),
								  temp_clock.GetPresentMonth(),
								  temp_clock.GetPresentDay() + 2,
								  temp_clock.GetPresentHour(),
								  temp_clock.GetPresentMinute());
	}
	else
	{
		loan_due_date = new Clock(temp_clock.GetPresentYear(),
								  temp_clock.GetPresentMonth(),
								  temp_clock.GetPresentDay() + 1,
								  temp_clock.GetPresentHour(),
								  temp_clock.GetPresentMinute());
	}
	_hold_event = Video_Hold_Event;
}


void Video::CancelHold()
{
	_hold_event = NULL;
}


LoanEvent* Video::GetVideoLoanEvent()
{
	return _Video_Loan;
}


HoldEvent* Video::GetVideoHoldEvent()
{
	return _hold_event;
}


string Video::GetDirectorName()const
{
	return _Director_Name;
}


Clock* Video::GetLoanDueDate()
{
	return loan_due_date;
}


int Video::GetLoanLength()const
{
	return _loan_length;
}


bool Video::IsLoanOverdue()
{
	if (loan_due_date->Is_earlier_than_present_time())
		return true;
	else
		return false;
}

string Video::GetRating()const
{
	return _rating;
}

void Video::Output()
{
	
	cout<<"The details of the video:  "<<endl;
	LibraryItem::Output();

	cout << "Director's  Name	:" <<_Director_Name <<endl;
	cout << "The rating of the video  :"<< _rating << endl;
}
