#include <iostream>
#include <string>
#include "VideoCollection.h"
using namespace std;


 
VideoCollection::VideoCollection()
{
}


void VideoCollection::AddVideo(string video_title, string video_barcode_num, 
							   string director_name, string video_rating, int loan_length)
{
	Video newVideo(video_title, video_barcode_num, director_name,video_rating, loan_length);
	_All_Video.push_back(newVideo);
	
}


void VideoCollection::RemoveVideo(string video_barcode)
{
	_All_Video.erase(GetVideoByBarcode(video_barcode));
}


Video *VideoCollection::GetVideoByBarcode(string video_barcode)
{
	Video video_temp;
	for (int i =0; i<_All_Video.size(); i++)
	{
		video_temp = _All_Video[i];
		if (video_temp.GetBarcodeNumber() == video_barcode)
		{
			return &_All_Video[i]; 
		};
	};
	return NULL;
}

VideoCollection *VideoCollection::GetVideoByTitle(string _by_vi_title)
{
	Video video_temp;
	VideoCollection* temp_video_collection = new VideoCollection;
	int flag = 0;

	for (int i =0; i<_All_Video.size(); i++)
	{
		video_temp = _All_Video[i];
		if (video_temp.GetTitle() == _by_vi_title)
		{
			temp_video_collection->AddVideo(_All_Video[i].GetTitle(), _All_Video[i].GetBarcodeNumber(),
											_All_Video[i].GetDirectorName(), _All_Video[i].GetRating(),
											_All_Video[i].GetLoanLength());
			flag = 1;
		};
	};
	
	if (flag ==0)
	{
		cout << "BOOK NOT FOUND!"<<endl;
		return NULL;
	}
	else 
		return temp_video_collection;
}


VideoCollection *VideoCollection::GetVideoByDirector(string _dir_name)
{
	Video video_temp;
	VideoCollection* temp_video_collection = new VideoCollection;
	int flag = 0;

	for (int i =0; i<_All_Video.size(); i++)
	{
		video_temp = _All_Video[i];
		if (video_temp.GetDirectorName() == _dir_name)
		{
			temp_video_collection->AddVideo(_All_Video[i].GetBarcodeNumber(), _All_Video[i].GetTitle(), 
											_All_Video[i].GetDirectorName(), _All_Video[i].GetRating(),
											_All_Video[i].GetLoanLength());
			flag = 1;
		};
	};
	
	if (flag ==0)
	{
		cout << "BOOK NOT FOUND!"<<endl;
		return NULL;
	}
	else 
		return temp_video_collection;
}

VideoCollection *VideoCollection::GetHoldFreeVideoByTitle(string title)
{
	Video video_temp;
	VideoCollection* temp_video_collection = new VideoCollection;
	int flag = 0;

	for (int i =0; i<_All_Video.size(); i++)
	{
		video_temp = _All_Video[i];
		if ( (video_temp.GetTitle() == title) && (!video_temp.OnHold()) )
		{
			temp_video_collection->AddVideo(_All_Video[i].GetTitle(),
											_All_Video[i].GetBarcodeNumber(),
											_All_Video[i].GetDirectorName(),
											_All_Video[i].GetRating(),
											_All_Video[i].GetLoanLength());
			flag = 1;
		};
	};

	if (flag ==0)
		return NULL;
	else 
		return temp_video_collection;
}


void VideoCollection::DisplayMemberWithOverdueVideos()
{
	Video video_temp;
	VideoCollection* temp_video_collection = new VideoCollection;
	int flag = 0;

	for (int i =0; i<_All_Video.size(); i++)
	{
		video_temp = _All_Video[i];
		if (video_temp.IsLoanOverdue())
		{
			cout << video_temp.GetVideoLoanEvent()->GetMember()->GetName() << endl;
		};
	};
}


void VideoCollection::Output()const
{

	Video _video;
	
	if (_All_Video.empty())
    {   
		cout << "No video in the library" << endl;
	
	}
	else
	{
		for (int n = 0; n < _All_Video.size() ; n++)
		{
			_video = _All_Video[n];
			_video.Output();
			if (_video.OnLoan())
			{
				cout << "Video loan due date : ";
				_video.GetLoanDueDate()->Output();
				cout << endl;
			}
		};
	};
}
