#ifndef VIDEOCOLLECTION_H
#define VIDEOCOLLECTION_H

#include <string>
#include <vector>
#include "Video.h"
using namespace std;

enum videosearch
{
	first_video,
	_by_video_title,
	_by_video_dir,
	last_video
};


class VideoCollection
{
public:
	VideoCollection();
	//---The current collection of video is undefined---
	// Pre :True
	// Post: True

	void AddVideo(string video_title, string video_barcode_num, string director_name, string video_rating, int loan_length);
	//--- This function adds a new video to the VideoCollection---
	// Pre   :video_title,video_barcode_num,director_name,video_rating,loan_length!=NULL
	// Post  :newVideo IsIn VideoCollection

	void RemoveVideo(string video_barcode);
	//---Remove a video by its barcode number, if the barcode match, the video is removed---
	// Pre   :True
	// Post  :Video->GetBarcodeNumber()==video_barcode && NOT(Video IsIn VideoCollection)

	Video *GetVideoByBarcode(string video_barcode);
	// ---Search a video by its barcode number, if the barcode match, return a pointer to the Video else return NULL---
	// Pre   :True
	// Post  :Video->GetBarcodeNumber() == video_barcode &&
    //             (Video IsIn VideoCollection &&
    //              return Video)
	//   	  OR
    //              return NULL

	VideoCollection *GetVideoByTitle(string _by_vi_title);
	// Pre   :True
	// Post  :Video->GetTitle() == _by_vi_title &&
    //             (Video IsIn VideoCollection &&
    //             return Video)
	//   	  OR
    //             return NULL

	VideoCollection *GetVideoByDirector(string _dir_name);
	// Pre   :True
	// Post  :Video->GetDirectorName() == _dir_name &&
    //             (Video IsIn VideoCollection &&
    //              return Video)
	//	      OR
    //              return NULL

	VideoCollection *GetHoldFreeVideoByTitle(string title);
	// Pre   :True
	// Post  :Video->GetTitle()==title && !=OnHold() &&
    //		      (Video IsIn VideoCollection &&
    //			  return Video)
	//   	  OR
    //			  return NULL

	void DisplayMemberWithOverdueVideos();
	//---To display a list of member with overdue videos---
	// Pre	  : True
	// Post	  : Video->IsLoanOverdue()==true && OUTPUTS( details of member)

	
	void Output()const;
	//---To display all the video details on the standard output---
	// Pre   :True
	// Post  :for_allVideo, Video IsIn VideoCollection : OUTPUT Video

private:
	vector <Video> _All_Video;
	Video *_Get_Video;
};

#endif
