#include "Year.h"
#include <iso646.h>
#include <iostream>
#include <iomanip>
using namespace std;


Year::Year()
{
}

Year::Year(int year_nr, BCAD indicator) 
: _year_nr(year_nr), _indicator(indicator)
{
}


void Year::Output() const
{
    cout <<"/" << _year_nr ;
}


bool Year::Is_leap_year() const
{
    return ((_year_nr % 4 == 0) and
            ((_year_nr % 100 != 0) or (_year_nr % 400 == 0)));
}


bool Year::Is_same_as(const Year &other_year) const
{
    return (_year_nr == other_year._year_nr) and
           (_indicator == other_year._indicator);
}


bool Year::Is_earlier_than(const Year &other_year) const
{
    return ( (!this->Is_later_than(other_year)) && (!this->Is_same_as(other_year)) );
}

bool Year::Is_later_than(const Year &other_year) const
{
    return (_indicator > other_year._indicator) or
           ((_indicator == BC) and (other_year._indicator == BC) and
            (_year_nr < other_year._year_nr)) or
           ((_indicator == AD) and (other_year._indicator == AD) and
            (_year_nr > other_year._year_nr));
}

Year Year::Next_year() const
{
    if (_indicator == AD)
        return Year(_year_nr+1, AD);
    else
        if (_year_nr > 1)
            return Year(_year_nr-1, BC);
        else
            return Year(0, AD);
}

