#ifndef already_included_year
#define already_included_year

#include <iostream>
using namespace std;

enum BCAD {BC, AD};

class Year
{
private:
    int _year_nr;
    BCAD _indicator;

public:
    Year();
    //---To create a Year object---
    // Pre:  True
    // Post: True

    Year(int year_nr, BCAD indicator=AD);
	//---Initialise all the member data and pass them as parameters to create a Year object---
    // Pre:  True
    // Post: A Year object has been created

    void Output() const;
	//---To output the details of the year---
    // Pre:  True
    // Post: OUTPUTS (details of the year)

    bool Is_leap_year() const;
	//---return true if and only if the year is a leap year---
    // Pre:  True
    // Post: returns _year_nr%4==0 OR (_year_nr%100==0 && _year_nr%400==0)

    bool Is_same_as(const Year &other_year) const;
	//---return true if and only if the year is same as other_year---
    // Pre:  True
    // Post: returns (_year_nr'==other _year._year_nr) && (_indicator'==other _year._indicator)

    bool Is_earlier_than(const Year &other_year) const;
	//---return true if and only if the year is earlier than other_year---
    // Pre:  True
    // Post: returns (_year_nr'<other _year._year_nr) && (_indicator'<other _year._indicator)

    bool Is_later_than(const Year &other_year) const;
    //---return true if and only if the year is later than other_year---
	// Pre:  True 
    // Post: returns (_year_nr'>other _year._year_nr) && (_indicator'>other _year._indicator)


    Year Next_year() const;
	//---returns year after the current year and whether it is BC or AD---
    // Pre:  True
    // Post: returns (_year_nr'==_year_nr+1) For AD OR (_year_nr'==_year_nr-1) For _year_nr>1
	//     	OR 0 For AD
};

#endif